-- phpMyAdmin SQL Dump
-- version 3.5.2
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generación: 12-01-2015 a las 11:33:24
-- Versión del servidor: 5.5.25a
-- Versión de PHP: 5.4.4

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de datos: `jbossews`
--

DELIMITER $$
--
-- Procedimientos
--
CREATE DEFINER=`adminN9Zkfeg`@`localhost` PROCEDURE `createNewProject`(vTitle VARCHAR(100) 
, vTechnicianID INT
,vContractorID INT
,vCoordinatorID INT)
BEGIN
  DECLARE newProjectId VARCHAR(8);
  SELECT getNewProjectId() INTO newProjectId FROM DUAL ;
  insert into project (ID,title,date_start, technician_ID, contractor_ID, coordinator_ID) 
  values(newProjectId,  vTitle,Now(), vTechnicianID, vContractorID, vCoordinatorID);
  INSERT INTO project_has_news(Project_ID, News_ID, date_news) VALUES(newProjectId, 1, NOW());
  COMMIT;
END$$

--
-- Funciones
--
CREATE DEFINER=`adminN9Zkfeg`@`localhost` FUNCTION `getNewProjectId`() RETURNS varchar(8) CHARSET latin1
    DETERMINISTIC
BEGIN
  DECLARE newProjectId VARCHAR(8);
  -- SET var_name = 0;
  SELECT  CONCAT('OB',DATE_FORMAT(NOW(),'%y'),'-',LPAD(CONVERT(RIGHT(ID,3),UNSIGNED INTEGER)+1,3,'0')) INTO newProjectId
  FROM project order by CONVERT(RIGHT(ID,3),UNSIGNED INTEGER) desc limit 1 ;

  
  
  -- SELECT if(value1 = 1,monto *divisa_dolar,monto *divisa_euro) INTO var_name
  --   FROM table
    -- WHERE data_init = 1;
  RETURN newProjectId ;
END$$

DELIMITER ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `city`
--

CREATE TABLE IF NOT EXISTS `city` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) DEFAULT NULL,
  `country_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_city_country` (`country_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `city`
--

INSERT INTO `city` (`ID`, `name`, `country_ID`) VALUES
(1, 'Barcelona', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `company`
--

CREATE TABLE IF NOT EXISTS `company` (
  `ID` int(11) NOT NULL,
  `name` varchar(45) DEFAULT NULL,
  `cif` varchar(45) DEFAULT NULL,
  `address` varchar(100) DEFAULT NULL,
  `postalcode` varchar(5) DEFAULT NULL,
  `location_ID` int(11) DEFAULT NULL,
  `telephone` varchar(10) DEFAULT NULL,
  `fax` varchar(45) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_Company_Location` (`location_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `company`
--

INSERT INTO `company` (`ID`, `name`, `cif`, `address`, `postalcode`, `location_ID`, `telephone`, `fax`, `email`) VALUES
(1, 'Diputación de Barcelona', 'P0800000B', 'Rambla de Catalunya, 126', '08008', 1, '934022222', '934022293', 'crisavis@uoc.edu'),
(2, 'Esye S.L.', 'B11111111', 'Muntaner, 276', '08008', 1, '933333333', '934444444', 'crisaviss@uoc.edu'),
(3, 'COGSI S.L', 'B22222222', 'Av Diagonal, 534', '08008', 1, '935555555', '9366666666', 'crisavis@uoc.edu');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `contractor`
--

CREATE TABLE IF NOT EXISTS `contractor` (
  `Company_ID` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `User_ID_UNIQUE` (`ID`),
  UNIQUE KEY `Company_ID_UNIQUE` (`Company_ID`),
  KEY `fk_Contractor_User` (`ID`),
  KEY `fk_Contractor_Company` (`Company_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `contractor`
--

INSERT INTO `contractor` (`Company_ID`, `ID`) VALUES
(3, 4);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `control_visit`
--

CREATE TABLE IF NOT EXISTS `control_visit` (
  `Project_ID` varchar(8) NOT NULL,
  `date` datetime NOT NULL,
  `report` varchar(2500) DEFAULT NULL,
  `image1` int(11) DEFAULT NULL,
  `image2` int(11) DEFAULT NULL,
  `image3` int(11) DEFAULT NULL,
  `image4` int(11) DEFAULT NULL,
  `image5` int(11) DEFAULT NULL,
  `image6` int(11) DEFAULT NULL,
  `sent` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`Project_ID`,`date`),
  KEY `fk_control_visit_Proyect1_idx` (`Project_ID`),
  KEY `fk_ControlVisit_files1` (`image1`),
  KEY `fk_ControlVisit_files2` (`image2`),
  KEY `fk_ControlVisit_files3` (`image3`),
  KEY `fk_ControlVisit_files4` (`image4`),
  KEY `fk_ControlVisit_files5` (`image5`),
  KEY `fk_ControlVisit_files6` (`image6`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `control_visit`
--

INSERT INTO `control_visit` (`Project_ID`, `date`, `report`, `image1`, `image2`, `image3`, `image4`, `image5`, `image6`, `sent`) VALUES
('OB14-001', '2014-10-14 00:00:00', '7777', NULL, NULL, NULL, NULL, NULL, NULL, 1),
('OB14-001', '2015-01-03 20:00:36', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL),
('OB14-001', '2015-01-05 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
('OB14-001', '2015-01-06 00:00:00', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `coordinator`
--

CREATE TABLE IF NOT EXISTS `coordinator` (
  `ID` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `nif` varchar(10) NOT NULL,
  `email` varchar(100) NOT NULL,
  `telephone` varchar(10) DEFAULT NULL,
  `company_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `User_ID_UNIQUE` (`ID`),
  KEY `fk_Coordinator_User` (`ID`),
  KEY `fk_Coordinator_Company` (`company_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `coordinator`
--

INSERT INTO `coordinator` (`ID`, `name`, `nif`, `email`, `telephone`, `company_ID`) VALUES
(3, 'Anna Moral Feijoo', '33333333P', 'crisavis@uoc.edu', '648334455', 2);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `country`
--

CREATE TABLE IF NOT EXISTS `country` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `country`
--

INSERT INTO `country` (`ID`, `name`) VALUES
(1, 'España');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `documents`
--

CREATE TABLE IF NOT EXISTS `documents` (
  `project_ID` varchar(8) NOT NULL DEFAULT '',
  `previous_advise` int(11) DEFAULT NULL,
  `tc2` int(11) DEFAULT NULL,
  `epis` int(11) DEFAULT NULL,
  `pss` int(11) DEFAULT NULL,
  `opening_workplace` int(11) DEFAULT NULL,
  `incidents_book` int(11) DEFAULT NULL,
  `subcontracting_book` int(11) DEFAULT NULL,
  `work_plan` int(11) DEFAULT NULL,
  `itv` int(11) DEFAULT NULL,
  `hospitals` int(11) DEFAULT NULL,
  `other1` int(11) DEFAULT NULL,
  `other2` int(11) DEFAULT NULL,
  PRIMARY KEY (`project_ID`),
  KEY `fk_documents_file1` (`previous_advise`),
  KEY `fk_documents_file2` (`tc2`),
  KEY `fk_documents_file3` (`epis`),
  KEY `fk_documents_file4` (`pss`),
  KEY `fk_documents_file5` (`opening_workplace`),
  KEY `fk_documents_file6` (`incidents_book`),
  KEY `fk_documents_file7` (`subcontracting_book`),
  KEY `fk_documents_file8` (`work_plan`),
  KEY `fk_documents_file9` (`itv`),
  KEY `fk_documents_file10` (`hospitals`),
  KEY `fk_documents_file11` (`other1`),
  KEY `fk_documents_file12` (`other2`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `documents`
--

INSERT INTO `documents` (`project_ID`, `previous_advise`, `tc2`, `epis`, `pss`, `opening_workplace`, `incidents_book`, `subcontracting_book`, `work_plan`, `itv`, `hospitals`, `other1`, `other2`) VALUES
('OB14-001', 1, 4, NULL, 2, NULL, NULL, 3, NULL, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `files`
--

CREATE TABLE IF NOT EXISTS `files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `original_name` varchar(100) DEFAULT NULL,
  `system_name` varchar(100) DEFAULT NULL,
  `path` varchar(200) DEFAULT NULL,
  `type_file` varchar(100) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `user_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_files_user` (`user_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

--
-- Volcado de datos para la tabla `files`
--

INSERT INTO `files` (`id`, `original_name`, `system_name`, `path`, `type_file`, `date`, `user_ID`) VALUES
(1, 'DocumentoPruebaAttach.txt', 'OB14-001AvisoPrevio.txt', 'C:\\PSSfiles\\OB14-001', 'text/plain', '2015-01-06', 3),
(2, 'imagen obra.jpg', 'OB14-001PSS.jpg', 'C:\\PSSfiles\\OB14-001', 'image/jpeg', '2015-01-06', 3),
(3, '06.526_Composicio_digital_PAC_04.pdf', 'OB14-001Subcontratistas.pdf', 'C:\\PSSfiles\\OB14-001', 'application/pdf', '2015-01-05', 3),
(4, 'DocumentoPruebaAttach.txt', 'OB14-001TC2.txt', 'C:\\PSSfiles\\OB14-001', 'text/plain', '2015-01-10', 3);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `location`
--

CREATE TABLE IF NOT EXISTS `location` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `name` varchar(50) DEFAULT NULL,
  `city_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_location_city` (`city_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `location`
--

INSERT INTO `location` (`ID`, `name`, `city_ID`) VALUES
(1, 'Abrera', 1),
(2, 'Aguilar de Segarra', 1),
(3, 'Aiguafreda', 1),
(4, 'Alella', 1),
(5, 'Alpens', 1),
(6, 'La Ametlla', 1),
(7, 'Arenys de Mar', 1),
(8, 'Arenys de Munt', 1),
(9, 'Argensola', 1),
(10, 'Argentona', 1),
(11, 'Artés', 1),
(12, 'Avinyó', 1),
(13, 'Aviá', 1),
(14, 'Badia del Vallès', 1),
(15, 'Bagá', 1),
(16, 'Balenyá', 1),
(17, 'Balsareny', 1),
(18, 'Barberá del Vallés', 1),
(19, 'Begas', 1),
(20, 'Bellprat', 1),
(21, 'Beulaigua (Osona)', 1),
(22, 'Bigas', 1),
(23, 'La Blava (Osona)', 1),
(24, 'Borgonyà (Osona)', 1),
(25, 'Borredá', 1),
(26, 'Bruch', 1),
(27, 'Brull (Barcelona)', 1),
(28, 'Las Cabanyas', 1),
(29, 'Cabrera de Igualada', 1),
(30, 'Cabrera de Mar', 1),
(31, 'Cabrils', 1),
(32, 'Calaf (España)', 1),
(33, 'Caldas de Montbui', 1),
(34, 'Calders', 1),
(35, 'Caldetas', 1),
(36, 'Calella', 1),
(37, 'Calldetenes', 1),
(38, 'Callús', 1),
(39, 'Calonge de Segarra', 1),
(40, 'Campins', 1),
(41, 'Can Palomeres', 1),
(42, 'Canet de Mar', 1),
(43, 'Canovellas', 1),
(44, 'Cánoves', 1),
(45, 'Cantonigròs (Osona)', 1),
(46, 'Canyellas', 1),
(47, 'Capellades', 1),
(48, 'Capolat', 1),
(49, 'Cardedeu', 1),
(50, 'Cardona', 1),
(51, 'Carme', 1),
(52, 'Caserras', 1),
(53, 'Casteldefels', 1),
(54, 'Castell del Areny', 1),
(55, 'Castellar de Nuch', 1),
(56, 'Castellar del Riu', 1),
(57, 'Castellar del Vallés', 1),
(58, 'Castellbell y Vilar', 1),
(59, 'Castellbisbal', 1),
(60, 'Castellcir', 1),
(61, 'Castellet y Gornal', 1),
(62, 'Castellfollit de Riubregós', 1),
(63, 'Castellfullit del Boix', 1),
(64, 'Castellgalí', 1),
(65, 'Castellnou de Bages', 1),
(66, 'Castellolí', 1),
(67, 'Castelltersol', 1),
(69, 'Castellví de la Marca', 1),
(70, 'Castellví de Rosanes', 1),
(71, 'Centellas', 1),
(72, 'Cervelló', 1),
(73, 'Collbató', 1),
(74, 'Collsuspina', 1),
(75, 'Colonia Güell', 1),
(76, 'Conanglell (Osona)', 1),
(77, 'Copóns', 1),
(78, 'Corbera de Llobregat', 1),
(79, 'Cornellá de Llobregat', 1),
(80, 'Cubellas', 1),
(81, 'Cussons (Osona)', 1),
(82, 'Daltmar', 1),
(83, 'El Despujol (Osona)', 1),
(84, 'Dosrius', 1),
(85, 'Esparraguera', 1),
(86, 'Esplugas de Llobregat', 1),
(87, 'Estany', 1),
(88, 'Figaró-Montmany', 1),
(89, 'Fígols', 1),
(90, 'Fogás de Monclús', 1),
(91, 'Fogás de Tordera', 1),
(92, 'Folgarolas', 1),
(93, 'Fonollosa', 1),
(94, 'Fontrubí', 1),
(95, 'Las Franquesas del Vallés', 1),
(96, 'Gallifa', 1),
(97, 'La Garriga', 1),
(98, 'Gavá', 1),
(99, 'Gayá', 1),
(100, 'Gelida', 1),
(101, 'Gironella', 1),
(102, 'Gisclareny', 1),
(103, 'La Gleva (Osona)', 1),
(104, 'Granera', 1),
(105, 'Granollers', 1),
(106, 'Gualba', 1),
(107, 'Guardiola', 1),
(108, 'Guardiola de Berga', 1),
(109, 'Gurb', 1),
(110, 'Els Hostalets de Pierola', 1),
(111, 'Igualada', 1),
(112, 'Jorba', 1),
(113, 'La Floresta (San Cugat del Vallés)', 1),
(114, 'La Granada', 1),
(115, 'La Llacuna', 1),
(116, 'La Llagosta', 1),
(117, 'Llinás del Vallés', 1),
(118, 'Llusá', 1),
(119, 'Malgrat de Mar', 1),
(120, 'Malla (Barcelona)', 1),
(121, 'Manlleu', 1),
(122, 'Manresa', 1),
(123, 'Marganell', 1),
(124, 'Martorell', 1),
(125, 'Martorellas', 1),
(126, 'Masías de Roda', 1),
(127, 'Las Masías de Voltregá', 1),
(128, 'El Masnou', 1),
(129, 'Masquefa', 1),
(130, 'Matadepera', 1),
(131, 'Mataró', 1),
(132, 'Mediona', 1),
(133, 'Molins de Rey', 1),
(134, 'Mollet del Vallès', 1),
(135, 'Moncada y Reixach', 1),
(136, 'Monistrol de Calders', 1),
(137, 'Monistrol de Montserrat', 1),
(138, 'Montanyola', 1),
(139, 'Montclar (Barcelona)', 1),
(140, 'Montesquiu', 1),
(141, 'Montgat', 1),
(142, 'Montmajor', 1),
(143, 'Montmaneu', 1),
(144, 'Montmeló', 1),
(145, 'Montornés del Vallés', 1),
(146, 'Montseny (Barcelona)', 1),
(147, 'Moyá', 1),
(148, 'Mura', 1),
(149, 'Navarclés', 1),
(150, 'Navás', 1),
(151, 'La Nou', 1),
(152, 'Ocata', 1),
(153, 'Ódena', 1),
(154, 'Olèrdola', 1),
(155, 'Olesa de Bonesvalls', 1),
(156, 'Olivella', 1),
(157, 'Olost', 1),
(158, 'Olván', 1),
(159, 'Ordal', 1),
(160, 'Orís', 1),
(161, 'Oristá', 1),
(162, 'Orpí', 1),
(163, 'Orrius', 1),
(164, 'Orsavinya', 1),
(165, 'Pachs del Panadés', 1),
(166, 'Palafolls', 1),
(167, 'Palau-solità i Plegamans', 1),
(168, 'Pallejá', 1),
(169, 'La Palma de Cervelló', 1),
(170, 'El Papiol', 1),
(171, 'Parets', 1),
(172, 'Perafita', 1),
(173, 'Piera', 1),
(174, 'Pineda de Mar', 1),
(175, 'Pla del Bon Aire', 1),
(176, 'Pla del Panadés', 1),
(177, 'La Pobla de Claramunt', 1),
(178, 'La Pobla de Lillet', 1),
(179, 'Polinyá', 1),
(180, 'Rocafort y Vilumara', 1),
(181, 'Pontons', 1),
(182, 'El Prat de Llobregat', 1),
(183, 'Prats de Llusanés', 1),
(184, 'Prats del Rey', 1),
(185, 'Premiá de Mar', 1),
(186, 'Premiá de Dalt', 1),
(187, 'Pruit', 1),
(188, 'Puigdalba', 1),
(189, 'Puigreig', 1),
(190, 'Pujalt', 1),
(191, 'La Quart', 1),
(192, 'Rajadell', 1),
(193, 'Rellinars', 1),
(194, 'Ripollet', 1),
(195, 'La Roca del Vallés', 1),
(196, 'Roda de Ter', 1),
(197, 'Rubió', 1),
(198, 'Rubí (Barcelona)', 1),
(199, 'Rupit y Pruït', 1),
(200, 'Sagás', 1),
(201, 'Salavinera', 1),
(202, 'Saldes', 1),
(203, 'Sallent de Llobregat', 1),
(204, 'Sampedor', 1),
(205, 'San Acisclo de Vallalta', 1),
(206, 'San Adrián de Besós', 1),
(207, 'San Agustín de Llusanés', 1),
(208, 'San Andrés de la Barca', 1),
(209, 'San Andrés de Llavaneras', 1),
(210, 'San Antonio de Vilamajor', 1),
(211, 'San Antonio Vilamajor', 1),
(212, 'San Bartolomé del Grau', 1),
(213, 'San Baudilio de Llobregat', 1),
(214, 'San Baudilio de Llusanés', 1),
(215, 'San Celoni', 1),
(216, 'San Cipriano de Vallalta', 1),
(217, 'San Clemente de Llobregat', 1),
(218, 'San Cugat del Vallés', 1),
(219, 'San Cugat Sasgarrigas', 1),
(220, 'San Esteban de Palautordera', 1),
(221, 'San Esteban de Sasroviras', 1),
(222, 'San Fausto de Campcentellas', 1),
(223, 'San Feliú de Llobregat', 1),
(224, 'San Felíu de Codinas', 1),
(225, 'San Felíu Saserra', 1),
(226, 'San Fructuoso de Bages', 1),
(227, 'San Hipólito de Voltregá', 1),
(228, 'San Jaime de Frontanya', 1),
(229, 'San Juan de Torruella', 1),
(230, 'San Julián de Cerdañola', 1),
(231, 'San Julián de Vilatorta', 1),
(232, 'San Justo Desvern', 1),
(233, 'San Lorenzo de Hortóns', 1),
(234, 'San Lorenzo Savall', 1),
(235, 'San Martín de Centellas', 1),
(236, 'San Martín de Riudeperas', 1),
(237, 'San Martín de Torruella', 1),
(238, 'San Martín de Tous', 1),
(239, 'San Martín del Bas', 1),
(240, 'San Martín Sarroca', 1),
(241, 'San Martín Sasgayolas', 1),
(242, 'San Martín Sescorts', 1),
(243, 'San Mateo de Bages', 1),
(244, 'San Pedro de Ribas', 1),
(245, 'San Pedro de Riudevitlles', 1),
(246, 'San Pedro de Torelló', 1),
(247, 'San Pedro de Vilamajor', 1),
(248, 'San Pol de Mar', 1),
(249, 'San Quintín de Mediona', 1),
(250, 'San Quirico de Besora', 1),
(251, 'San Quirico de Tarrasa', 1),
(252, 'San Quirico Safaja', 1),
(253, 'San Sadurní de Noya', 1),
(254, 'San Saturnino de Osormot', 1),
(255, 'San Vicente de Castellet', 1),
(256, 'San Vicente de Montalt', 1),
(257, 'San Vicente de Torelló', 1),
(258, 'San Vicente dels Horts', 1),
(259, 'Sant Andreu de la Vola (Osona)', 1),
(260, 'Sant Feliu del Racó', 1),
(261, 'Sant Miquel d''Ordeig (Osona)', 1),
(262, 'Sant Miquel de Balenyà (Osona)', 1),
(263, 'Santa Cecilia de Voltregá', 1),
(264, 'Santa Coloma de Cervelló', 1),
(265, 'Santa Creu de Jutglar (Osona)', 1),
(266, 'Santa Eugenia de Berga', 1),
(267, 'Santa Eulalia de Riuprimer', 1),
(268, 'Santa Eulalia de Ronsana', 1),
(269, 'Santa Eulàlia de Puig-oriol', 1),
(270, 'Santa Fe del Panadés', 1),
(271, 'Santa Margarita de Montbuy', 1),
(272, 'Santa Margarita y Monjós', 1),
(273, 'Santa Maria de Corcó', 1),
(274, 'Santa María de Besora', 1),
(275, 'Santa María de Marlés', 1),
(276, 'Santa María de Martorellas de Arriba', 1),
(277, 'Santa María de Miralles', 1),
(278, 'Santa María de Oló', 1),
(279, 'Santa María de Palautordera', 1),
(280, 'Santa Perpetua de Moguda', 1),
(281, 'Santa Susana (Barcelona)', 1),
(282, 'Sardañola del Vallés', 1),
(283, 'Senmanat', 1),
(284, 'Sentforas', 1),
(285, 'Serchs', 1),
(286, 'Serraparera', 1),
(287, 'Seva (España)', 1),
(288, 'Sobirans', 1),
(289, 'Sobremunt', 1),
(290, 'Sora (Barcelona)', 1),
(291, 'Suria', 1),
(292, 'Tabérnolas', 1),
(293, 'Tagamanent', 1),
(294, 'Talamanca (Barcelona)', 1),
(295, 'Taradell', 1),
(296, 'Tavertet', 1),
(297, 'Teyá', 1),
(298, 'Tiana', 1),
(299, 'Tona (España)', 1),
(300, 'Tordera', 1),
(301, 'Torelló', 1),
(302, 'La Torre d''Oristà (Osona)', 1),
(303, 'Torre de Claramunt', 1),
(304, 'Torrelavit', 1),
(305, 'Torrellas de Foix', 1),
(306, 'Torrellas de Llobregat', 1),
(307, 'Ullastrell', 1),
(308, 'Vacarisas', 1),
(309, 'Vallbona', 1),
(310, 'Vallcebre', 1),
(311, 'Vallgorguina', 1),
(312, 'Vallirana', 1),
(313, 'Vallromanes', 1),
(314, 'Veciana', 1),
(315, 'Vila-seca (Osona)', 1),
(316, 'Vilada', 1),
(317, 'Viladecaballs', 1),
(318, 'Vilalleons (Osona)', 1),
(319, 'Vilanova de Sau', 1),
(320, 'Vilanova del Camí', 1),
(321, 'Vilanova del Vallés', 1),
(322, 'Vilasar de Dalt', 1),
(323, 'Vilasar de Mar', 1),
(324, 'Villalba Saserra', 1),
(325, 'Villanueva y Geltrú', 1),
(326, 'Viloví', 1),
(327, 'Vinyoles d''Orís (Osona)', 1),
(328, 'Viver y Serrateix', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `manager`
--

CREATE TABLE IF NOT EXISTS `manager` (
  `ID` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `nif` varchar(10) NOT NULL,
  `email` varchar(100) NOT NULL,
  `company_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `User_ID_UNIQUE` (`ID`),
  KEY `fk_Manager_User` (`ID`),
  KEY `fk_Manager_Company` (`company_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `manager`
--

INSERT INTO `manager` (`ID`, `name`, `nif`, `email`, `company_ID`) VALUES
(1, 'Inma Aranda Vidal', '11111111H', 'crisavis@uoc.edu', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `manager_manages_technician`
--

CREATE TABLE IF NOT EXISTS `manager_manages_technician` (
  `manager_ID` int(11) NOT NULL DEFAULT '0',
  `technician_ID` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`manager_ID`,`technician_ID`),
  KEY `fk_manager_manages_technician_Technician` (`technician_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `manager_manages_technician`
--

INSERT INTO `manager_manages_technician` (`manager_ID`, `technician_ID`) VALUES
(1, 2);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `news`
--

CREATE TABLE IF NOT EXISTS `news` (
  `ID` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `news`
--

INSERT INTO `news` (`ID`, `name`) VALUES
(1, 'Obra creada'),
(2, 'Obra modificada'),
(3, 'Visita de control'),
(4, 'Obra cerrada');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `project`
--

CREATE TABLE IF NOT EXISTS `project` (
  `ID` varchar(8) NOT NULL,
  `date_start` datetime DEFAULT NULL,
  `title` varchar(100) DEFAULT NULL,
  `road` varchar(45) DEFAULT NULL,
  `PK` varchar(45) DEFAULT NULL,
  `months` int(11) DEFAULT NULL,
  `budget` float DEFAULT NULL,
  `site_manager_ID` int(11) DEFAULT NULL,
  `technician_ID` int(11) DEFAULT NULL,
  `contractor_ID` int(11) DEFAULT NULL,
  `coordinator_ID` int(11) DEFAULT NULL,
  `created` datetime DEFAULT NULL,
  `data_close` date DEFAULT NULL,
  `close_comments` varchar(1500) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_Project_Site_Manager` (`site_manager_ID`),
  KEY `fk_Project_Technician` (`technician_ID`),
  KEY `fk_Project_Contractor` (`contractor_ID`),
  KEY `fk_Project_Coordinator` (`coordinator_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `project`
--

INSERT INTO `project` (`ID`, `date_start`, `title`, `road`, `PK`, `months`, `budget`, `site_manager_ID`, `technician_ID`, `contractor_ID`, `coordinator_ID`, `created`, `data_close`, `close_comments`) VALUES
('OB14-001', '2013-12-25 00:00:00', 'Mejora de una carretera', 'BV2249', '30', 10, 100000, 1, 2, 4, 3, '2014-10-07 00:00:00', NULL, NULL),
('OB14-002', '2014-11-27 21:15:09', 'Rehabilitación del Firme con Mezclas Bituminosas en Caliente.', NULL, NULL, NULL, NULL, NULL, 2, 4, 3, '2014-10-07 00:00:00', NULL, NULL),
('OB14-003', '2014-12-24 00:00:00', 'ooooooooooooooooooo', 'CV1234', '23', 6, 200000, NULL, 2, 4, 3, '2014-12-01 00:00:00', '2015-01-02', 'ssssss'),
('OB14-004', '2015-01-05 00:00:00', 'gggggggggggggg', '11', '11', 11, 111, 8, 2, 4, 3, '2014-12-02 00:00:00', NULL, NULL),
('OB15-001', NULL, 'asasasasasasasasasasa', NULL, NULL, NULL, NULL, NULL, 2, 4, 3, '2015-01-06 16:54:40', NULL, NULL),
('OB15-002', NULL, 'zzzzzzzzzzzzzzzzzzzzzzzzzzzzzz', NULL, NULL, NULL, NULL, NULL, 2, 4, 3, '2015-01-06 17:27:59', NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `project_has_news`
--

CREATE TABLE IF NOT EXISTS `project_has_news` (
  `Project_ID` varchar(8) NOT NULL,
  `News_ID` int(11) NOT NULL,
  `date_news` date NOT NULL,
  KEY `fk_Proyect_has_New_New1_idx` (`News_ID`),
  KEY `fk_Proyect_has_New_Proyect1_idx` (`Project_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `project_has_news`
--

INSERT INTO `project_has_news` (`Project_ID`, `News_ID`, `date_news`) VALUES
('OB14-001', 1, '2014-11-06'),
('OB14-001', 3, '2014-12-21'),
('OB14-002', 1, '2014-11-27'),
('OB14-003', 1, '2014-12-03'),
('OB14-003', 4, '2014-12-28'),
('OB14-004', 1, '2014-12-03'),
('OB14-003', 4, '2015-01-02'),
('OB14-003', 4, '2015-01-02'),
('OB14-001', 4, '2015-01-05'),
('OB15-001', 1, '2015-01-06'),
('OB15-002', 1, '2015-01-06');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `role`
--

CREATE TABLE IF NOT EXISTS `role` (
  `ID` int(11) NOT NULL,
  `name` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `role`
--

INSERT INTO `role` (`ID`, `name`) VALUES
(1, 'Jefe de la Diputación'),
(2, 'Técnico de la Diputación'),
(3, 'Coordinador de Seguridad y Salud'),
(4, 'Contratista');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_manager`
--

CREATE TABLE IF NOT EXISTS `site_manager` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `nif` varchar(45) DEFAULT NULL,
  `name` varchar(45) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `telephone` varchar(10) DEFAULT NULL,
  `Company_ID` int(11) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_Site_Manager_Company1_idx` (`Company_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=9 ;

--
-- Volcado de datos para la tabla `site_manager`
--

INSERT INTO `site_manager` (`ID`, `nif`, `name`, `email`, `telephone`, `Company_ID`) VALUES
(1, '44444444A', 'Pau Vidal Albar...', 'crisavis@uoc.edu', '939898989', 3),
(2, '09332888H', 'Joan', 'crisavis@uoc.edu', '8787878787', 3),
(3, '', '', '', '', 3),
(4, '093311111H', 'Isabel ', 'crisavis@uoc.edu', '11223344', 3),
(5, '22222n', 'Roberto Foz', 'crisavis@uoc.edu', '9111111111', 3),
(6, '1111111f', 'Roberto Foz', 'crisavis@uoc.edu', '9111111111', 3),
(7, '1111111f', 'rererere', 'crisavis@uoc.edu', '111111', 3),
(8, '1111111f', 'Felix Fernandez', 'crisavis@uoc.edu', '911111111', 3);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `status`
--

CREATE TABLE IF NOT EXISTS `status` (
  `ID` int(11) NOT NULL,
  `name` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `status`
--

INSERT INTO `status` (`ID`, `name`) VALUES
(1, 'Muy bueno'),
(2, 'Bueno'),
(3, 'Básico'),
(4, 'Insuficiente');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `technician`
--

CREATE TABLE IF NOT EXISTS `technician` (
  `ID` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `nif` varchar(10) NOT NULL,
  `email` varchar(100) NOT NULL,
  `telephone` varchar(10) DEFAULT NULL,
  `company_ID` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `User_ID_UNIQUE` (`ID`),
  KEY `fk_Technician_User` (`ID`),
  KEY `fk_Technician_Company` (`company_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `technician`
--

INSERT INTO `technician` (`ID`, `name`, `nif`, `email`, `telephone`, `company_ID`) VALUES
(2, 'Joan Rueda Solé', '22222222J', 'crisavis@uoc.edu', '637223344', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user`
--

CREATE TABLE IF NOT EXISTS `user` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `username` varchar(15) NOT NULL,
  `password` varchar(45) NOT NULL,
  `Role_ID` int(11) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `fk_User_Rol1_idx` (`Role_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `user`
--

INSERT INTO `user` (`ID`, `username`, `password`, `Role_ID`) VALUES
(1, 'user1', 'tfg', 1),
(2, 'user2', 'tfg', 2),
(3, 'user3', 'tfg', 3),
(4, 'user4', 'tfg', 4);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `visit_epcs`
--

CREATE TABLE IF NOT EXISTS `visit_epcs` (
  `Project_ID` varchar(8) NOT NULL,
  `date` datetime NOT NULL,
  `first_aid_kit` tinyint(1) DEFAULT NULL,
  `handrail` tinyint(1) DEFAULT NULL,
  `safety_nets` tinyint(1) DEFAULT NULL,
  `lifeline` tinyint(1) DEFAULT NULL,
  `CO2_extinguishers` tinyint(1) DEFAULT NULL,
  `water_extinguishers` tinyint(1) DEFAULT NULL,
  `powder_extinguishers` tinyint(1) DEFAULT NULL,
  `comments` varchar(1000) NOT NULL DEFAULT 'null',
  `status_ID` int(11) NOT NULL,
  `image1` int(11) DEFAULT NULL,
  `image2` int(11) DEFAULT NULL,
  PRIMARY KEY (`Project_ID`,`date`),
  KEY `fk_Visit_Epcs_status1` (`status_ID`),
  KEY `fk_Visit_Epcs_file1` (`image1`),
  KEY `fk_Visit_Epcs_file2` (`image2`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `visit_epcs`
--

INSERT INTO `visit_epcs` (`Project_ID`, `date`, `first_aid_kit`, `handrail`, `safety_nets`, `lifeline`, `CO2_extinguishers`, `water_extinguishers`, `powder_extinguishers`, `comments`, `status_ID`, `image1`, `image2`) VALUES
('OB14-001', '2014-10-14 00:00:00', 0, 0, 0, 0, 1, 1, 1, '22', 3, NULL, NULL),
('OB14-001', '2015-01-03 20:00:36', 0, 0, 0, 0, 0, 0, 0, '', 2, NULL, NULL),
('OB14-001', '2015-01-05 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL),
('OB14-001', '2015-01-06 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `visit_epis`
--

CREATE TABLE IF NOT EXISTS `visit_epis` (
  `Project_ID` varchar(8) NOT NULL,
  `date` datetime NOT NULL,
  `helmet` tinyint(1) DEFAULT NULL,
  `face_shield` tinyint(1) DEFAULT NULL,
  `harness` tinyint(1) DEFAULT NULL,
  `reflective_jacket` tinyint(1) DEFAULT NULL,
  `glasses` tinyint(1) DEFAULT NULL,
  `boots` tinyint(1) DEFAULT NULL,
  `earmuffs` tinyint(1) DEFAULT NULL,
  `gloves` tinyint(1) DEFAULT NULL,
  `mask` tinyint(1) DEFAULT NULL,
  `cap` tinyint(1) DEFAULT NULL,
  `comments` varchar(1000) DEFAULT 'null',
  `status_ID` int(11) NOT NULL,
  `image1` int(11) DEFAULT NULL,
  `image2` int(11) DEFAULT NULL,
  PRIMARY KEY (`Project_ID`,`date`),
  KEY `fk_Visit_Epis_states1` (`status_ID`),
  KEY `fk_Visit_Epis_file1` (`image1`),
  KEY `fk_Visit_Epis_file2` (`image2`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `visit_epis`
--

INSERT INTO `visit_epis` (`Project_ID`, `date`, `helmet`, `face_shield`, `harness`, `reflective_jacket`, `glasses`, `boots`, `earmuffs`, `gloves`, `mask`, `cap`, `comments`, `status_ID`, `image1`, `image2`) VALUES
('OB14-001', '2014-10-14 00:00:00', 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, '11111111111111111', 3, NULL, NULL),
('OB14-001', '2015-01-03 20:00:36', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'null', 2, NULL, NULL),
('OB14-001', '2015-01-05 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL),
('OB14-001', '2015-01-06 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `visit_signage`
--

CREATE TABLE IF NOT EXISTS `visit_signage` (
  `project_ID` varchar(8) NOT NULL,
  `date` datetime NOT NULL,
  `road_way` int(11) DEFAULT NULL,
  `fix` tinyint(1) DEFAULT NULL,
  `mobile` tinyint(1) DEFAULT NULL,
  `cones` tinyint(1) DEFAULT NULL,
  `semaphore` tinyint(1) DEFAULT NULL,
  `speed_bumps` tinyint(1) DEFAULT NULL,
  `traffic_controller` tinyint(1) DEFAULT NULL,
  `TP3` tinyint(1) DEFAULT NULL,
  `TP15` tinyint(1) DEFAULT NULL,
  `TP15a` tinyint(1) DEFAULT NULL,
  `TP15b` tinyint(1) DEFAULT NULL,
  `TP17` tinyint(1) DEFAULT NULL,
  `TP17a` tinyint(1) DEFAULT NULL,
  `TP17b` tinyint(1) DEFAULT NULL,
  `TP18` tinyint(1) DEFAULT NULL,
  `TP19` tinyint(1) DEFAULT NULL,
  `TP25` tinyint(1) DEFAULT NULL,
  `TP28` tinyint(1) DEFAULT NULL,
  `TP30` tinyint(1) DEFAULT NULL,
  `TP50` tinyint(1) DEFAULT NULL,
  `TR301` tinyint(1) DEFAULT NULL,
  `TR302` tinyint(1) DEFAULT NULL,
  `TR303` tinyint(1) DEFAULT NULL,
  `TR305` tinyint(1) DEFAULT NULL,
  `comments` varchar(1000) NOT NULL DEFAULT 'null',
  `status_ID` int(11) NOT NULL,
  `image1` int(11) DEFAULT NULL,
  `image2` int(11) DEFAULT NULL,
  PRIMARY KEY (`project_ID`,`date`),
  KEY `fk_Visit_Signage_status1_idx` (`status_ID`),
  KEY `fk_Visit_Signage_file1` (`image1`),
  KEY `fk_Visit_Signage_file2` (`image2`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `visit_signage`
--

INSERT INTO `visit_signage` (`project_ID`, `date`, `road_way`, `fix`, `mobile`, `cones`, `semaphore`, `speed_bumps`, `traffic_controller`, `TP3`, `TP15`, `TP15a`, `TP15b`, `TP17`, `TP17a`, `TP17b`, `TP18`, `TP19`, `TP25`, `TP28`, `TP30`, `TP50`, `TR301`, `TR302`, `TR303`, `TR305`, `comments`, `status_ID`, `image1`, `image2`) VALUES
('OB14-001', '2014-10-14 00:00:00', 2, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, '33', 3, NULL, NULL),
('OB14-001', '2015-01-03 20:00:36', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, '', 2, NULL, NULL),
('OB14-001', '2015-01-05 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL),
('OB14-001', '2015-01-06 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura Stand-in para la vista `vw_news`
--
CREATE TABLE IF NOT EXISTS `vw_news` (
`ID` varchar(8)
,`title` varchar(100)
,`date_news` date
,`name` varchar(100)
,`newsid` int(11)
);
-- --------------------------------------------------------

--
-- Estructura para la vista `vw_news`
--
DROP TABLE IF EXISTS `vw_news`;

CREATE ALGORITHM=UNDEFINED DEFINER=`adminN9Zkfeg`@`localhost` SQL SECURITY DEFINER VIEW `vw_news` AS select `project`.`ID` AS `ID`,`project`.`title` AS `title`,`project_has_news`.`date_news` AS `date_news`,`news`.`name` AS `name`,`news`.`ID` AS `newsid` from ((`news` join `project_has_news` on((`news`.`ID` = `project_has_news`.`News_ID`))) join `project` on((`project`.`ID` = `project_has_news`.`Project_ID`)));

--
-- Restricciones para tablas volcadas
--

--
-- Filtros para la tabla `city`
--
ALTER TABLE `city`
  ADD CONSTRAINT `fk_city_country` FOREIGN KEY (`country_ID`) REFERENCES `country` (`ID`);

--
-- Filtros para la tabla `company`
--
ALTER TABLE `company`
  ADD CONSTRAINT `fk_Company_Location` FOREIGN KEY (`location_ID`) REFERENCES `location` (`ID`);

--
-- Filtros para la tabla `contractor`
--
ALTER TABLE `contractor`
  ADD CONSTRAINT `fk_Contractor_Company` FOREIGN KEY (`Company_ID`) REFERENCES `company` (`ID`),
  ADD CONSTRAINT `fk_Contractor_User` FOREIGN KEY (`ID`) REFERENCES `user` (`ID`);

--
-- Filtros para la tabla `control_visit`
--
ALTER TABLE `control_visit`
  ADD CONSTRAINT `fk_ControlVisit_files1` FOREIGN KEY (`image1`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_files2` FOREIGN KEY (`image2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_files3` FOREIGN KEY (`image3`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_files4` FOREIGN KEY (`image4`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_files5` FOREIGN KEY (`image5`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_files6` FOREIGN KEY (`image6`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_ControlVisit_Project` FOREIGN KEY (`Project_ID`) REFERENCES `project` (`ID`);

--
-- Filtros para la tabla `coordinator`
--
ALTER TABLE `coordinator`
  ADD CONSTRAINT `fk_Coordinator_Company` FOREIGN KEY (`company_ID`) REFERENCES `company` (`ID`),
  ADD CONSTRAINT `fk_Coordinator_User` FOREIGN KEY (`ID`) REFERENCES `user` (`ID`);

--
-- Filtros para la tabla `documents`
--
ALTER TABLE `documents`
  ADD CONSTRAINT `fk_documents_file1` FOREIGN KEY (`previous_advise`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file10` FOREIGN KEY (`hospitals`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file11` FOREIGN KEY (`other1`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file12` FOREIGN KEY (`other2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file2` FOREIGN KEY (`tc2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file3` FOREIGN KEY (`epis`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file4` FOREIGN KEY (`pss`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file5` FOREIGN KEY (`opening_workplace`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file6` FOREIGN KEY (`incidents_book`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file7` FOREIGN KEY (`subcontracting_book`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file8` FOREIGN KEY (`work_plan`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_documents_file9` FOREIGN KEY (`itv`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Documents_Project` FOREIGN KEY (`project_ID`) REFERENCES `project` (`ID`);

--
-- Filtros para la tabla `files`
--
ALTER TABLE `files`
  ADD CONSTRAINT `fk_files_user` FOREIGN KEY (`user_ID`) REFERENCES `user` (`ID`);

--
-- Filtros para la tabla `location`
--
ALTER TABLE `location`
  ADD CONSTRAINT `fk_location_city` FOREIGN KEY (`city_ID`) REFERENCES `city` (`ID`);

--
-- Filtros para la tabla `manager`
--
ALTER TABLE `manager`
  ADD CONSTRAINT `fk_Manager_Company` FOREIGN KEY (`company_ID`) REFERENCES `company` (`ID`),
  ADD CONSTRAINT `fk_Manager_User` FOREIGN KEY (`ID`) REFERENCES `user` (`ID`);

--
-- Filtros para la tabla `manager_manages_technician`
--
ALTER TABLE `manager_manages_technician`
  ADD CONSTRAINT `fk_manager_manages_technician_Manager` FOREIGN KEY (`manager_ID`) REFERENCES `manager` (`ID`),
  ADD CONSTRAINT `fk_manager_manages_technician_Technician` FOREIGN KEY (`technician_ID`) REFERENCES `technician` (`ID`);

--
-- Filtros para la tabla `project`
--
ALTER TABLE `project`
  ADD CONSTRAINT `fk_Project_Contractor` FOREIGN KEY (`contractor_ID`) REFERENCES `contractor` (`ID`),
  ADD CONSTRAINT `fk_Project_Coordinador` FOREIGN KEY (`coordinator_ID`) REFERENCES `coordinator` (`ID`),
  ADD CONSTRAINT `fk_Project_Site_manager` FOREIGN KEY (`site_manager_ID`) REFERENCES `site_manager` (`ID`),
  ADD CONSTRAINT `fk_Project_Technician` FOREIGN KEY (`technician_ID`) REFERENCES `technician` (`ID`);

--
-- Filtros para la tabla `project_has_news`
--
ALTER TABLE `project_has_news`
  ADD CONSTRAINT `fk_Project_has_News_New1` FOREIGN KEY (`News_ID`) REFERENCES `news` (`ID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  ADD CONSTRAINT `fk_Project_has_News_Proyect1` FOREIGN KEY (`Project_ID`) REFERENCES `project` (`ID`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Filtros para la tabla `site_manager`
--
ALTER TABLE `site_manager`
  ADD CONSTRAINT `fk_Site_Manager_Company1` FOREIGN KEY (`Company_ID`) REFERENCES `company` (`ID`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Filtros para la tabla `technician`
--
ALTER TABLE `technician`
  ADD CONSTRAINT `fk_technician_Company` FOREIGN KEY (`company_ID`) REFERENCES `company` (`ID`),
  ADD CONSTRAINT `fk_Technician_User` FOREIGN KEY (`ID`) REFERENCES `user` (`ID`);

--
-- Filtros para la tabla `user`
--
ALTER TABLE `user`
  ADD CONSTRAINT `fk_User_Role` FOREIGN KEY (`Role_ID`) REFERENCES `role` (`ID`);

--
-- Filtros para la tabla `visit_epcs`
--
ALTER TABLE `visit_epcs`
  ADD CONSTRAINT `fk_Visit_Epcs_ControlVisit` FOREIGN KEY (`Project_ID`, `date`) REFERENCES `control_visit` (`Project_ID`, `date`),
  ADD CONSTRAINT `fk_Visit_Epcs_file1` FOREIGN KEY (`image1`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Epcs_file2` FOREIGN KEY (`image2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Epcs_status` FOREIGN KEY (`status_ID`) REFERENCES `status` (`ID`);

--
-- Filtros para la tabla `visit_epis`
--
ALTER TABLE `visit_epis`
  ADD CONSTRAINT `fk_Visit_Epis_Control_visit1` FOREIGN KEY (`Project_ID`, `date`) REFERENCES `control_visit` (`Project_ID`, `date`),
  ADD CONSTRAINT `fk_Visit_Epis_file1` FOREIGN KEY (`image1`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Epis_file2` FOREIGN KEY (`image2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Epis_states1` FOREIGN KEY (`status_ID`) REFERENCES `status` (`ID`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Filtros para la tabla `visit_signage`
--
ALTER TABLE `visit_signage`
  ADD CONSTRAINT `fk_Visit_Signage_Control_visit1` FOREIGN KEY (`project_ID`, `date`) REFERENCES `control_visit` (`Project_ID`, `date`),
  ADD CONSTRAINT `fk_Visit_Signage_file1` FOREIGN KEY (`image1`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Signage_file2` FOREIGN KEY (`image2`) REFERENCES `files` (`id`),
  ADD CONSTRAINT `fk_Visit_Signage_status1` FOREIGN KEY (`status_ID`) REFERENCES `status` (`ID`) ON DELETE NO ACTION ON UPDATE NO ACTION;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
