package com.ccalvouoc.actions;

import java.util.Date;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.UserDao;
import com.ccalvouoc.orm.User;
import com.ccalvouoc.utils.EmailUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class ChangePassAction extends ActionSupport implements SessionAware {
	
	private static final Logger logger = Logger.getLogger(ChangePassAction.class.getName());
	
	private Map session;
	private UserSession user;

	private String inputOldPassword;
	private String inputNewPassword;
	private String inputNewPasswordAgain;
	
	private String error;
	
	
	@Override
	public String execute() throws Exception { 			
		try {
			Utilities utilities = new Utilities();
			user = utilities.getUserSession(session);			
			if (user==null){				
				return ActionSupport.LOGIN;
			}
			
			if(!validateForm()){
				return ActionSupport.ERROR;	
			}
			
			//modifica el password	
			UserDao userDao= new UserDao();
			User userToUpdate = userDao.getUser(user.getId());
			userToUpdate.setPassword(inputNewPassword);
			userDao.mergePass(userToUpdate);
			
		} catch(Exception ex) {
		
			logger.error(ex.getMessage(), ex);
			addActionError("Ha ocurrido algún problema y no se ha completado la operación. Vuelva a intentarlo.");
			return ActionSupport.ERROR;		
		}		
		return ActionSupport.SUCCESS;
	}
	
	
	
	
	
	private boolean validateForm() {		
		if(inputOldPassword == null || inputOldPassword.equals("")) {
			addActionError("Debe rellenar el campo 'Contraseña actual'");
			return false;
		}else if(inputNewPassword == null || inputNewPassword.equals("")) {
			addActionError("Debe rellenar el campo 'Nueva contraseña'");
			return false;
		}else if(inputNewPasswordAgain == null || inputNewPasswordAgain.equals("")) {
			addActionError("Debe rellenar el campo 'Repetir Nueva contraseña'");
			return false;
		}else if(!inputNewPasswordAgain.equals(inputNewPassword)) {
			addActionError("Las contraseñas no coinciden.");
			return false;
		}else if (!validatePassword()){
			addActionError("La contraseña es incorrecta.");
			return false;
		}
		return true;
	}
	
	
	private boolean validatePassword(){
		UserDao userDao = new UserDao();
		if (!userDao.allowAccess(user.getUserName(), inputOldPassword)) {
			return false;
		}
		return true;
	}
	
	

	public Map getSession() {
		return session;
	}
	public void setSession(Map session) {
		this.session = session;
	}
	public UserSession getUser() {
		return user;
	}
	public void setUser(UserSession user) {
		this.user = user;
	}



	public String getInputOldPassword() {
		return inputOldPassword;
	}



	public void setInputOldPassword(String inputOldPassword) {
		this.inputOldPassword = inputOldPassword;
	}



	public String getInputNewPassword() {
		return inputNewPassword;
	}



	public void setInputNewPassword(String inputNewPassword) {
		this.inputNewPassword = inputNewPassword;
	}



	public String getInputNewPasswordAgain() {
		return inputNewPasswordAgain;
	}



	public void setInputNewPasswordAgain(String inputNewPasswordAgain) {
		this.inputNewPasswordAgain = inputNewPasswordAgain;
	}





	public String getError() {
		return error;
	}





	public void setError(String error) {
		this.error = error;
	}	
	
	
	
}
