package com.ccalvouoc.actions;

import java.util.Date;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.utils.EmailUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class ContactFormAction extends ActionSupport implements SessionAware {
	
	private static final Logger logger = Logger.getLogger(ContactFormAction.class.getName());
	
	private Map session;
	private UserSession user;
	private String subject;	
	private String comments;
	
	
	@Override
	public String execute() throws Exception { 			
		try {
			Utilities utilities = new Utilities();
			user = utilities.getUserSession(session);			
			if (user==null){				
				return ActionSupport.LOGIN;
			}
			
			if(!validateForm()){
				return ActionSupport.ERROR;	
			}
			
			EmailUtils.sendMail(EmailUtils.NO_REPLY_EMAIL_ADDRESS, EmailUtils.ADMIN_EMAIL_ADDRESS, subject, getBodyText());			
			logger.info("Correo enviado desde el formulario de contacto por el usuario: " + user.getId());		
		} catch(Exception ex) {
		
			logger.error(ex.getMessage(), ex);
			addActionError("Ha ocurrido algún problema y no se ha completado la operación. Vuelva a intentarlo.");
			return ActionSupport.ERROR;		
		}		
		return ActionSupport.SUCCESS;
	}
	
	
	
	public String showContactForm() throws Exception { 			
		try {
			Utilities utilities = new Utilities();
			user = utilities.getUserSession(session);			
			if (user==null){				
				return ActionSupport.LOGIN;
			}
		} catch(Exception ex) {		
			logger.error(ex.getMessage(), ex);
			return ActionSupport.ERROR;		
		}		
		return ActionSupport.INPUT;
	}	
	
	private boolean validateForm() {		
		if(comments == null || comments.equals("")) {
			addActionError("Debe rellenar el campo 'Comentario'");
			return false;
		}
		return true;
	}
	
	
	private String getBodyText() {
		StringBuilder sbBodyText = new StringBuilder();
		sbBodyText.append("Usuario: " ).append(user.getUserName());
		sbBodyText.append(System.lineSeparator());		
		sbBodyText.append("ID: ").append(user.getId());
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append("Fecha: ").append(new Date());
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append("Mensaje:");
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append(comments);		
		return sbBodyText.toString();		
	}
	

	public Map getSession() {
		return session;
	}
	public void setSession(Map session) {
		this.session = session;
	}
	public UserSession getUser() {
		return user;
	}
	public void setUser(UserSession user) {
		this.user = user;
	}	
	
	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public String getComments() {
		return comments;
	}

	public void setComments(String comments) {
		this.comments = comments;
	}

	
}
