package com.ccalvouoc.actions;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.ControlVisitDao;
import com.ccalvouoc.dao.FilesDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.dao.UserDao;
import com.ccalvouoc.orm.ControlVisit;
import com.ccalvouoc.orm.ControlVisitId;
import com.ccalvouoc.orm.Files;
import com.ccalvouoc.orm.Project;
import com.ccalvouoc.orm.User;
import com.ccalvouoc.utils.EmailUtils;
import com.ccalvouoc.utils.FileUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class ControlVisitEditionAction extends ActionSupport implements
		SessionAware {
	
	private static final Logger logger = Logger.getLogger(ControlVisitEditionAction.class.getName());
	
	private ControlVisit controlVisit;

	private String projectId;
	private String date;

	private Map session;
	private UserSession user;

	// variables form
	private String report;
	private String buttonName;

	// imágenes
	private File epiImage1;
	private String epiImage1ContentType;
	private String epiImage1FileName;
	
	
	private File epiImage2;
	private String epiImage2ContentType;
	private String epiImage2FileName;

	private File epcImage1;
	private String epcImage1ContentType;
	private String epcImage1FileName;	
	
	private File epcImage2;
	private String epcImage2ContentType;
	private String epcImage2FileName;	

	private File signageImage1;
	private String signageImage1ContentType;
	private String signageImage1FileName;	
	
	private File signageImage2;
	private String signageImage2ContentType;
	private String signageImage2FileName;	

	private File reportImage1;
	private String reportImage1ContentType;
	private String reportImage1FileName;		
	
	private File reportImage2;
	private String reportImage2ContentType;
	private String reportImage2FileName;		
	
	private File reportImage3;
	private String reportImage3ContentType;
	private String reportImage3FileName;
	
	
	private File reportImage4;
	private String reportImage4ContentType;
	private String reportImage4FileName;
	
	
	private File reportImage5;
	private String reportImage5ContentType;
	private String reportImage5FileName;	
	
	private File reportImage6;	
	private String reportImage6ContentType;
	private String reportImage6FileName;


	@Override
	public String execute() throws Exception {
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);

		if (user == null) {

			return ActionSupport.LOGIN;
		}

		

		if (buttonName.equals("Guardar")) {
			// guardar la visita, esta podrá ser editada por el coordinador
			// posteriormente hasta que sea enviada
			
			updateControlVisit();

			addActionMessage("Los datos han sido actualizados");
		} else if (buttonName.equals("Enviar")) {
			// Enviar la visita por mail
			// actualizar la visita en las noticias
			// cerrar la visita de control para que no pueda ser editada

			
			addActionMessage("Se ha enviado el correo");
			sendControlVisit();

		}else if (buttonName.equals("Borrar")) {
			// Eliminar la visita
			
			deleteControlVisit();
			return "list";
		}
		

		return ActionSupport.SUCCESS;
	}

	
	public String saveControlVisitEdition() throws Exception {
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);
		if (user == null) {
			return ActionSupport.LOGIN;
		}
		
		updateControlVisit();
		addActionMessage("Los datos han sido actualizados");		
		return display();		
	}
	
	public String sendMailControlVisitEdition() throws Exception { 
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);
		if (user == null) {
			return ActionSupport.LOGIN;
		}
		
		sendControlVisit();		
		sendEmail();
		addActionMessage("Se ha enviado el correo");
		return ActionSupport.SUCCESS;
	}
	
	
	
	public String display() throws Exception {
		
		
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);

		if (user == null) {

			return ActionSupport.LOGIN;
		}
		
		Date visitDate = new Date(Long.parseLong(date));
		ControlVisitDao controlVisitDao = new ControlVisitDao();
		controlVisit = controlVisitDao.getControlVisit(projectId, visitDate);
		
		return NONE;

	}
	
	private void deleteControlVisit(){
		ControlVisitDao controlVisitDao= new ControlVisitDao();
		ControlVisit controlVisitToRemove =  controlVisitDao.getControlVisit(controlVisit.getId().getProjectId(), 
				controlVisit.getId().getDate());
		
		controlVisitDao.removeControlVisit(controlVisitToRemove);
		
	}
	private void sendControlVisit() throws Exception {
		controlVisit.setSent(true);
		updateControlVisit();
		ProjectDao projectDao= new ProjectDao();
		projectDao.addNewsControlVisit(controlVisit.getProject());
		
	}
	private void updateControlVisit() throws Exception{		
		
		ControlVisitDao controlVisitDao = new ControlVisitDao();
		controlVisit.getVisitEpis().setId(controlVisit.getId());
		ControlVisit controlVisitToUpdate= controlVisitDao.getControlVisit(controlVisit.getId().getProjectId(), 
				controlVisit.getId().getDate());

		setDataControlVisitToUpdate(controlVisitToUpdate, controlVisit);
		
		//saveAllImages();

		controlVisit= controlVisitDao.saveControlVisit(controlVisitToUpdate);
		
	}
	
	private void setDataControlVisitToUpdate(ControlVisit controlVisitToUpdate, ControlVisit controlVisitData) throws Exception{		
		// ControlVisit
		controlVisitToUpdate.setReport(controlVisitData.getReport());		
		
		// Epi
		updateEPIsData(controlVisitToUpdate, controlVisitData);
		
		// Epc
		updateEPCsData(controlVisitToUpdate, controlVisitData);
		
		
		// Signage
		updateSignageData(controlVisitToUpdate, controlVisitData);
		
		//Image Report
		updateImageReport(controlVisitToUpdate);

		controlVisitToUpdate.setSent(controlVisitData.getSent());		
	}
	
	
	private void updateEPIsData(ControlVisit controlVisitToUpdate, ControlVisit controlVisitData) throws Exception {
		controlVisitToUpdate.getVisitEpis().setBoots(controlVisitData.getVisitEpis().getBoots());
		controlVisitToUpdate.getVisitEpis().setCap(controlVisitData.getVisitEpis().getCap());
		controlVisitToUpdate.getVisitEpis().setEarmuffs(controlVisitData.getVisitEpis().getEarmuffs());
		controlVisitToUpdate.getVisitEpis().setFaceShield(controlVisitData.getVisitEpis().getFaceShield());
		controlVisitToUpdate.getVisitEpis().setGlasses(controlVisitData.getVisitEpis().getGlasses());
		controlVisitToUpdate.getVisitEpis().setGloves(controlVisitData.getVisitEpis().getGloves());
		controlVisitToUpdate.getVisitEpis().setHarness(controlVisitData.getVisitEpis().getHarness());
		controlVisitToUpdate.getVisitEpis().setHelmet(controlVisitData.getVisitEpis().getHelmet());
		controlVisitToUpdate.getVisitEpis().setMask(controlVisitData.getVisitEpis().getMask());
		controlVisitToUpdate.getVisitEpis().setReflectiveJacket(controlVisitData.getVisitEpis().getReflectiveJacket());
		controlVisitToUpdate.getVisitEpis().setComments(controlVisitData.getVisitEpis().getComments());
		controlVisitToUpdate.getVisitEpis().getStatus().setId(controlVisitData.getVisitEpis().getStatus().getId());		
		if(epiImage1!= null && epiImage1ContentType.contains("image")){
			Files fileEpiImage1 = null;
			if(controlVisitToUpdate.getVisitEpis().getFilesByImage1()!=null) {
				//Actualizamos la imagen
				fileEpiImage1 = updateImage(controlVisitToUpdate.getVisitEpis().getFilesByImage1().getId(), epiImage1, "epiImage1", epiImage1FileName, epiImage1ContentType);
			}else {
				//Grabamos la imagen
				fileEpiImage1 = saveImage(epiImage1, "epiImage1", epiImage1FileName, epiImage1ContentType);
			}			
			controlVisitToUpdate.getVisitEpis().setFilesByImage1(fileEpiImage1);
		}	
		
		if(epiImage2!= null && epiImage2ContentType.contains("image")){		
			Files fileEpiImage2 = null;
			if(controlVisitToUpdate.getVisitEpis().getFilesByImage2()!=null) {
				//Actualizamos la imagen
				fileEpiImage2 = updateImage(controlVisitToUpdate.getVisitEpis().getFilesByImage2().getId(), epiImage2, "epiImage2", epiImage2FileName, epiImage2ContentType);
			}else {
				//Grabamos la imagen
				fileEpiImage2 = saveImage(epiImage2, "epiImage2", epiImage2FileName, epiImage2ContentType);
			}			
			controlVisitToUpdate.getVisitEpis().setFilesByImage2(fileEpiImage2);
		}		
	}
	
	
	private void updateEPCsData(ControlVisit controlVisitToUpdate, ControlVisit controlVisitData) throws Exception {
		controlVisitToUpdate.getVisitEpcs().setCo2Extinguishers(controlVisitData.getVisitEpcs().getCo2Extinguishers());
		controlVisitToUpdate.getVisitEpcs().setFirstAidKit(controlVisitData.getVisitEpcs().getFirstAidKit());
		controlVisitToUpdate.getVisitEpcs().setHandrail(controlVisitData.getVisitEpcs().getHandrail());
		controlVisitToUpdate.getVisitEpcs().setLifeline(controlVisitData.getVisitEpcs().getLifeline());
		controlVisitToUpdate.getVisitEpcs().setPowderExtinguishers(controlVisitData.getVisitEpcs().getPowderExtinguishers());
		controlVisitToUpdate.getVisitEpcs().setSafetyNets(controlVisitData.getVisitEpcs().getSafetyNets());
		controlVisitToUpdate.getVisitEpcs().setWaterExtinguishers(controlVisitData.getVisitEpcs().getWaterExtinguishers());
		controlVisitToUpdate.getVisitEpcs().setComments(controlVisitData.getVisitEpcs().getComments());
		controlVisitToUpdate.getVisitEpcs().getStatus().setId(controlVisitData.getVisitEpcs().getStatus().getId());
		if(epcImage1!= null && epcImage1ContentType.contains("image")){
			Files fileEpcImage1 = null;
			if(controlVisitToUpdate.getVisitEpcs().getFilesByImage1()!=null) {
				//Actualizamos la imagen
				fileEpcImage1 = updateImage(controlVisitToUpdate.getVisitEpcs().getFilesByImage1().getId(), epcImage1, "epcImage1", epcImage1FileName, epcImage1ContentType);
			}else {
				//Grabamos la imagen
				fileEpcImage1 = saveImage(epcImage1, "epcImage1", epcImage1FileName, epcImage1ContentType);
			}			
			controlVisitToUpdate.getVisitEpcs().setFilesByImage1(fileEpcImage1);
		}	
		
		if(epcImage2!= null && epcImage2ContentType.contains("image")){		
			Files fileEpcImage2 = null;
			if(controlVisitToUpdate.getVisitEpcs().getFilesByImage2()!=null) {
				//Actualizamos la imagen
				fileEpcImage2 = updateImage(controlVisitToUpdate.getVisitEpcs().getFilesByImage2().getId(), epcImage2, "epcImage2", epcImage2FileName, epcImage2ContentType);
			}else {
				//Grabamos la imagen
				fileEpcImage2 = saveImage(epcImage2, "epcImage2", epcImage2FileName, epcImage2ContentType);
			}			
			controlVisitToUpdate.getVisitEpcs().setFilesByImage2(fileEpcImage2);
		}
		
	}
	
	
	private void updateSignageData(ControlVisit controlVisitToUpdate, ControlVisit controlVisitData) throws Exception { 
		controlVisitToUpdate.getVisitSignage().setCones(controlVisitData.getVisitSignage().getCones());
		controlVisitToUpdate.getVisitSignage().setFix(controlVisitData.getVisitSignage().getFix());
		controlVisitToUpdate.getVisitSignage().setMobile(controlVisitData.getVisitSignage().getMobile());
		controlVisitToUpdate.getVisitSignage().setRoadWay(controlVisitData.getVisitSignage().getRoadWay());
		controlVisitToUpdate.getVisitSignage().setSemaphore(controlVisitData.getVisitSignage().getSemaphore());
		controlVisitToUpdate.getVisitSignage().setSpeedBumps(controlVisitData.getVisitSignage().getSpeedBumps());
		controlVisitToUpdate.getVisitSignage().setTrafficController(controlVisitData.getVisitSignage().getTrafficController());
		controlVisitToUpdate.getVisitSignage().setTp15(controlVisitData.getVisitSignage().getTp15());
		controlVisitToUpdate.getVisitSignage().setTp15a(controlVisitData.getVisitSignage().getTp15a());
		controlVisitToUpdate.getVisitSignage().setTp15b(controlVisitData.getVisitSignage().getTp15b());
		controlVisitToUpdate.getVisitSignage().setTp17(controlVisitData.getVisitSignage().getTp17());
		controlVisitToUpdate.getVisitSignage().setTp17a(controlVisitData.getVisitSignage().getTp17a());
		controlVisitToUpdate.getVisitSignage().setTp17b(controlVisitData.getVisitSignage().getTp17b());
		controlVisitToUpdate.getVisitSignage().setTp18(controlVisitData.getVisitSignage().getTp18());
		controlVisitToUpdate.getVisitSignage().setTp19(controlVisitData.getVisitSignage().getTp19());
		controlVisitToUpdate.getVisitSignage().setTp25(controlVisitData.getVisitSignage().getTp25());
		controlVisitToUpdate.getVisitSignage().setTp28(controlVisitData.getVisitSignage().getTp28());
		controlVisitToUpdate.getVisitSignage().setTp3(controlVisitData.getVisitSignage().getTp3());
		controlVisitToUpdate.getVisitSignage().setTp30(controlVisitData.getVisitSignage().getTp30());
		controlVisitToUpdate.getVisitSignage().setTr301(controlVisitData.getVisitSignage().getTr301());
		controlVisitToUpdate.getVisitSignage().setTr302(controlVisitData.getVisitSignage().getTr302());
		controlVisitToUpdate.getVisitSignage().setTr303(controlVisitData.getVisitSignage().getTr303());
		controlVisitToUpdate.getVisitSignage().setTr305(controlVisitData.getVisitSignage().getTr305());
		controlVisitToUpdate.getVisitSignage().setComments(controlVisitData.getVisitSignage().getComments());
		controlVisitToUpdate.getVisitSignage().getStatus().setId(controlVisitData.getVisitSignage().getStatus().getId());
		
		if(signageImage1!= null && signageImage1ContentType.contains("image")){
			Files fileSignageImage1 = null;
			if(controlVisitToUpdate.getVisitSignage().getFilesByImage1()!=null) {
				//Actualizamos la imagen
				fileSignageImage1 = updateImage(controlVisitToUpdate.getVisitSignage().getFilesByImage1().getId(), signageImage1, "signageImage1", signageImage1FileName, signageImage1ContentType);
			}else {
				//Grabamos la imagen
				fileSignageImage1 = saveImage(signageImage1, "signageImage1", signageImage1FileName, signageImage1ContentType);
			}			
			controlVisitToUpdate.getVisitSignage().setFilesByImage1(fileSignageImage1);
		}	
		
		if(signageImage2!= null && signageImage2ContentType.contains("image")){		
			Files fileSignageImage2 = null;
			if(controlVisitToUpdate.getVisitSignage().getFilesByImage2()!=null) {
				//Actualizamos la imagen
				fileSignageImage2 = updateImage(controlVisitToUpdate.getVisitSignage().getFilesByImage2().getId(), signageImage2, "signageImage2", signageImage2FileName, signageImage2ContentType);
			}else {
				//Grabamos la imagen
				fileSignageImage2 = saveImage(signageImage2, "signageImage2", signageImage2FileName, signageImage2ContentType);
			}			
			controlVisitToUpdate.getVisitSignage().setFilesByImage2(fileSignageImage2);
		}
	}
	
	
	
	private void updateImageReport(ControlVisit controlVisitToUpdate) throws Exception {
		if(reportImage1!= null && reportImage1ContentType.contains("image")){
			Files fileReportImage1 = null;
			if(controlVisitToUpdate.getFilesByImage1() !=null) {
				//Actualizamos la imagen
				fileReportImage1 = updateImage(controlVisitToUpdate.getFilesByImage1().getId(), reportImage1, "reportImage1", reportImage1FileName, reportImage1ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage1 = saveImage(reportImage1, "reportImage1", reportImage1FileName, reportImage1ContentType);
			}			
			controlVisitToUpdate.setFilesByImage1(fileReportImage1);
		}
		
		if(reportImage2!= null && reportImage2ContentType.contains("image")){
			Files fileReportImage2 = null;
			if(controlVisitToUpdate.getFilesByImage2() !=null) {
				//Actualizamos la imagen
				fileReportImage2 = updateImage(controlVisitToUpdate.getFilesByImage2().getId(), reportImage2, "reportImage2", reportImage2FileName, reportImage2ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage2 = saveImage(reportImage2, "reportImage2", reportImage2FileName, reportImage2ContentType);
			}			
			controlVisitToUpdate.setFilesByImage2(fileReportImage2);
		}	
		
		
		if(reportImage3!= null && reportImage3ContentType.contains("image")){
			Files fileReportImage3 = null;
			if(controlVisitToUpdate.getFilesByImage3() !=null) {
				//Actualizamos la imagen
				fileReportImage3 = updateImage(controlVisitToUpdate.getFilesByImage3().getId(), reportImage3, "reportImage3", reportImage3FileName, reportImage3ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage3 = saveImage(reportImage3, "reportImage3", reportImage3FileName, reportImage3ContentType);
			}			
			controlVisitToUpdate.setFilesByImage3(fileReportImage3);
		}		
		
		if(reportImage4!= null && reportImage4ContentType.contains("image")){
			Files fileReportImage4 = null;
			if(controlVisitToUpdate.getFilesByImage4() !=null) {
				//Actualizamos la imagen
				fileReportImage4 = updateImage(controlVisitToUpdate.getFilesByImage4().getId(), reportImage4, "reportImage4", reportImage4FileName, reportImage4ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage4 = saveImage(reportImage4, "reportImage4", reportImage4FileName, reportImage4ContentType);
			}			
			controlVisitToUpdate.setFilesByImage4(fileReportImage4);
		}	
		
		if(reportImage5!= null && reportImage5ContentType.contains("image")){
			Files fileReportImage5 = null;
			if(controlVisitToUpdate.getFilesByImage5() !=null) {
				//Actualizamos la imagen
				fileReportImage5 = updateImage(controlVisitToUpdate.getFilesByImage5().getId(), reportImage5, "reportImage5", reportImage5FileName, reportImage5ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage5 = saveImage(reportImage5, "reportImage5", reportImage5FileName, reportImage5ContentType);
			}			
			controlVisitToUpdate.setFilesByImage5(fileReportImage5);
		}
		
		if(reportImage6!= null && reportImage6ContentType.contains("image")){
			Files fileReportImage6 = null;
			if(controlVisitToUpdate.getFilesByImage6() !=null) {
				//Actualizamos la imagen
				fileReportImage6 = updateImage(controlVisitToUpdate.getFilesByImage6().getId(), reportImage6, "reportImage6", reportImage6FileName, reportImage6ContentType);
			}else {
				//Grabamos la imagen
				fileReportImage6 = saveImage(reportImage6, "reportImage6", reportImage6FileName, reportImage6ContentType);
			}			
			controlVisitToUpdate.setFilesByImage6(fileReportImage6);
		}	
	}
	
	
	
	private Files saveImage(File imageFile, String imageName, String clientName, String imageContentType) throws Exception {  		
		
		String filePath = getFilePath();
    	String imageNameInServer = getImageName(imageName, clientName);
    	
    	UserDao userDao = new UserDao();
    	User userSaving = userDao.getUser(user.getId());
		
		//Se graba en BBDD y obtenemos el id		
		Files fileToBeSave = new Files();
		fileToBeSave.setUser(userSaving);
		fileToBeSave.setOriginalName(clientName);
		fileToBeSave.setSystemName(imageNameInServer);
		fileToBeSave.setPath(filePath);
		fileToBeSave.setTypeFile(imageContentType);
		fileToBeSave.setDate(new Date());		
		FilesDao filesDao = new FilesDao();
		int idNewFile = filesDao.addFile(fileToBeSave);    	

    	//Se graba la imagen original en el sistema de archivos
    	FileUtils.saveFileOnDisk(imageFile, imageNameInServer, filePath);
    	
    	//se graba un thumbnail de la imagen original en el sistema de archivos
    	FileUtils.saveThumbnail(imageFile,"th"+ imageNameInServer, filePath);
    	
    	//Devolvemos el registro en la tabla Files correspondiente al fichero grabado
    	Files savedFile = filesDao.fileById(idNewFile);    	
    	return savedFile;

	}
	
	private Files updateImage(int idFileToBeUpdated, File imageFile, String imageName, String clientName, String imageContentType) throws Exception {  			
		
		String filePath = getFilePath();
    	String imageNameInServer = getImageName(imageName, clientName);
    	
    	UserDao userDao = new UserDao();
    	User userSaving = userDao.getUser(user.getId());
		
		//Se actualiza en BBDD 
		FilesDao filesDao = new FilesDao();
    	Files fileToBeUpdated = filesDao.fileById(idFileToBeUpdated);
		fileToBeUpdated.setUser(userSaving);
		fileToBeUpdated.setOriginalName(clientName);
		fileToBeUpdated.setSystemName(imageNameInServer);
		fileToBeUpdated.setPath(filePath);
		fileToBeUpdated.setTypeFile(imageContentType);
		fileToBeUpdated.setDate(new Date());		
		filesDao.mergeFile(fileToBeUpdated);    	

    	//Se graba la imagen original en el sistema de archivos
    	FileUtils.saveFileOnDisk(imageFile, imageNameInServer, filePath);
    	
    	//se graba un thumbnail de la imagen original en el sistema de archivos
    	FileUtils.saveThumbnail(imageFile,"th"+ imageNameInServer, filePath);    	

    	//Devolvemos el registro en la tabla Files correspondiente al fichero actualizado 	
    	return fileToBeUpdated;

	}
	
	
	
	private Files createFilesObject(String imageName, String clientName, String imageContentType) {
    	UserDao userDao = new UserDao();
    	User userSaving = userDao.getUser(user.getId());
    	String filePath = getFilePath();    	
		Files fileInSystem = new Files();
		fileInSystem.setUser(userSaving);
		fileInSystem.setOriginalName(clientName);
		fileInSystem.setSystemName(imageName);
		fileInSystem.setPath(filePath);
		fileInSystem.setTypeFile(imageContentType);
		fileInSystem.setDate(new Date());		
		return fileInSystem;
		
	}
	
	private String getFilePath() {
		String filePath = "";
    	Date date = controlVisit.getId().getDate();

    	SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
    	String formattedDate = formatter.format(date);
    	
		filePath = "PSSfiles" +  File.separator + controlVisit.getProject().getId() +  File.separator + formattedDate;
		
        //FilesUtil.saveFile(getFile(), getFileFileName(), context.getRealPath("") + File.separator + filesPath);
    	String directorioRaiz = System.getenv("OPENSHIFT_DATA_DIR");
    	if(directorioRaiz !=null && !directorioRaiz.equals("")) {
    		filePath = directorioRaiz + File.separator + filePath;        		
    	} else {
    		filePath = "C:" + File.separator + filePath;  
    	}
    	return filePath;		
	}
	
    private String getImageName(String imageName, String clientName) {
    	
    	String extension = clientName.substring(clientName.lastIndexOf('.'));   
    	Date date = controlVisit.getId().getDate();
    	SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
    	String formattedDate = formatter.format(date);    	
    	StringBuilder sb = new StringBuilder();
    	sb.append(controlVisit.getId().getProjectId()).append(formattedDate).append(imageName).append(extension);    	
    	return sb.toString();
    } 
    
    private void sendEmail() throws Exception {
    	
    	ProjectDao projectDao= new ProjectDao();
    	Project project = projectDao.getProject(projectId);    	
    	
    	String bodyText = getBodyText(project);
    	String subject = "Se ha realizado una nueva visita de obra";
    	
    	String emailTechnician = project.getTechnician().getEmail();
    	EmailUtils.sendMail(EmailUtils.NO_REPLY_EMAIL_ADDRESS, emailTechnician, subject, bodyText);		
    	
    	String emailCoordinator = project.getCoordinator().getEmail();
    	EmailUtils.sendMail(EmailUtils.NO_REPLY_EMAIL_ADDRESS, emailCoordinator, subject, bodyText);
    	
    	String emailManager = project.getSiteManager().getEmail();
    	EmailUtils.sendMail(EmailUtils.NO_REPLY_EMAIL_ADDRESS, emailManager, subject, bodyText);   	
    	
    }
    
    
	private String getBodyText(Project project) {
		StringBuilder sbBodyText = new StringBuilder();
		sbBodyText.append("Se han realizado una nueva visita a la siguiente obra: ");
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append("Código: " ).append(project.getId());
		sbBodyText.append(System.lineSeparator());		
		sbBodyText.append("Titulo: ").append(project.getTitle());
		sbBodyText.append(System.lineSeparator());		
		String stringDate = new SimpleDateFormat("dd-MM-yyyy").format(controlVisit.getId().getDate());
		sbBodyText.append("Fecha: ").append(stringDate);
		sbBodyText.append(System.lineSeparator());
		sbBodyText.append("Enlace:  https://jbossews-ccalvouoc.rhcloud.com/");
		sbBodyText.append(System.lineSeparator());
		return sbBodyText.toString();		
	}

	public ControlVisit getControlVisit() {
		return controlVisit;
	}

	public void setControlVisit(ControlVisit controlVisit) {
		this.controlVisit = controlVisit;
	}

	public String getProjectId() {
		return projectId;
	}

	public void setProjectId(String projectId) {
		this.projectId = projectId;
	}

	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}

	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	

	public UserSession getUser() {
		return user;
	}


	public void setUser(UserSession user) {
		this.user = user;
	}


	public String getReport() {
		return report;
	}

	public void setReport(String report) {
		this.report = report;
	}

	public String getButtonName() {
		return buttonName;
	}

	public void setButtonName(String buttonName) {
		this.buttonName = buttonName;
	}

	public File getEpiImage1() {
		return epiImage1;
	}

	public void setEpiImage1(File epiImage1) {
		this.epiImage1 = epiImage1;
	}

	public File getEpiImage2() {
		return epiImage2;
	}

	public void setEpiImage2(File epiImage2) {
		this.epiImage2 = epiImage2;
	}

	public File getEpcImage1() {
		return epcImage1;
	}

	public void setEpcImage1(File epcImage1) {
		this.epcImage1 = epcImage1;
	}

	public File getEpcImage2() {
		return epcImage2;
	}

	public void setEpcImage2(File epcImage2) {
		this.epcImage2 = epcImage2;
	}

	public File getSignageImage1() {
		return signageImage1;
	}

	public void setSignageImage1(File signageImage1) {
		this.signageImage1 = signageImage1;
	}

	public File getSignageImage2() {
		return signageImage2;
	}

	public void setSignageImage2(File signageImage2) {
		this.signageImage2 = signageImage2;
	}

	public File getReportImage1() {
		return reportImage1;
	}

	public void setReportImage1(File reportImage1) {
		this.reportImage1 = reportImage1;
	}

	public File getReportImage2() {
		return reportImage2;
	}

	public void setReportImage2(File reportImage2) {
		this.reportImage2 = reportImage2;
	}

	public File getReportImage3() {
		return reportImage3;
	}

	public void setReportImage3(File reportImage3) {
		this.reportImage3 = reportImage3;
	}

	public File getReportImage4() {
		return reportImage4;
	}

	public void setReportImage4(File reportImage4) {
		this.reportImage4 = reportImage4;
	}

	public File getReportImage5() {
		return reportImage5;
	}

	public void setReportImage5(File reportImage5) {
		this.reportImage5 = reportImage5;
	}

	public File getReportImage6() {
		return reportImage6;
	}

	public void setReportImage6(File reportImage6) {
		this.reportImage6 = reportImage6;
	}
	
	public void setEpiImage1ContentType(String epiImage1ContentType) {
		this.epiImage1ContentType = epiImage1ContentType;
	}


	public void setEpiImage1FileName(String epiImage1FileName) {
		this.epiImage1FileName = epiImage1FileName;
	}


	public void setEpiImage2ContentType(String epiImage2ContentType) {
		this.epiImage2ContentType = epiImage2ContentType;
	}


	public void setEpiImage2FileName(String epiImage2FileName) {
		this.epiImage2FileName = epiImage2FileName;
	}


	public void setEpcImage1ContentType(String epcImage1ContentType) {
		this.epcImage1ContentType = epcImage1ContentType;
	}


	public void setEpcImage1FileName(String epcImage1FileName) {
		this.epcImage1FileName = epcImage1FileName;
	}


	public void setEpcImage2ContentType(String epcImage2ContentType) {
		this.epcImage2ContentType = epcImage2ContentType;
	}


	public void setEpcImage2FileName(String epcImage2FileName) {
		this.epcImage2FileName = epcImage2FileName;
	}


	public void setSignageImage1ContentType(String signageImage1ContentType) {
		this.signageImage1ContentType = signageImage1ContentType;
	}


	public void setSignageImage1FileName(String signageImage1FileName) {
		this.signageImage1FileName = signageImage1FileName;
	}


	public void setSignageImage2ContentType(String signageImage2ContentType) {
		this.signageImage2ContentType = signageImage2ContentType;
	}


	public void setSignageImage2FileName(String signageImage2FileName) {
		this.signageImage2FileName = signageImage2FileName;
	}


	public void setReportImage1ContentType(String reportImage1ContentType) {
		this.reportImage1ContentType = reportImage1ContentType;
	}


	public void setReportImage1FileName(String reportImage1FileName) {
		this.reportImage1FileName = reportImage1FileName;
	}


	public void setReportImage2ContentType(String reportImage2ContentType) {
		this.reportImage2ContentType = reportImage2ContentType;
	}


	public void setReportImage2FileName(String reportImage2FileName) {
		this.reportImage2FileName = reportImage2FileName;
	}


	public void setReportImage3ContentType(String reportImage3ContentType) {
		this.reportImage3ContentType = reportImage3ContentType;
	}


	public void setReportImage3FileName(String reportImage3FileName) {
		this.reportImage3FileName = reportImage3FileName;
	}


	public void setReportImage4ContentType(String reportImage4ContentType) {
		this.reportImage4ContentType = reportImage4ContentType;
	}


	public void setReportImage4FileName(String reportImage4FileName) {
		this.reportImage4FileName = reportImage4FileName;
	}


	public void setReportImage5ContentType(String reportImage5ContentType) {
		this.reportImage5ContentType = reportImage5ContentType;
	}


	public void setReportImage5FileName(String reportImage5FileName) {
		this.reportImage5FileName = reportImage5FileName;
	}


	public void setReportImage6ContentType(String reportImage6ContentType) {
		this.reportImage6ContentType = reportImage6ContentType;
	}


	public void setReportImage6FileName(String reportImage6FileName) {
		this.reportImage6FileName = reportImage6FileName;
	}
	
	
	
	
}
