package com.ccalvouoc.actions;

import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.ContractorDao;
import com.ccalvouoc.dao.CoordinatorDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.ejemplo.PrimeraClase;
import com.ccalvouoc.orm.Contractor;
import com.ccalvouoc.orm.Coordinator;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class DoNewProjectAction extends ActionSupport implements SessionAware {
	private static final Logger logger = Logger.getLogger(DoNewProjectAction.class.getName());

	private Map session;
	private UserSession user;

	// Variables para cargar las listas desplegables en pantalla
	private List<Coordinator> listCoordinators;
	private List<Contractor> listContractors;

	// Variables que recoge del formulario
	private String title;
	private String coordinatorId;
	private String contractorId;

	public DoNewProjectAction() {


		// rellena las listas de coordinadores y contratistas
		CoordinatorDao coordinatorDao = new CoordinatorDao();
		listCoordinators = coordinatorDao.listCoordinators();

		ContractorDao contractorDao = new ContractorDao();
		listContractors = contractorDao.listContractors();
	}

	@Override
	public String execute() throws Exception {
		Utilities utilities = new Utilities();
		user= utilities.getUserSession(session);
		if (user!= null){
		// Crea el nuevo proyecto
		
		ProjectDao projectDao = new ProjectDao();
		

		
		  String projectCode =
		  projectDao.createNewProject(title,user.getId(),
		  Integer.parseInt(coordinatorId) , Integer.parseInt(contractorId));
		  
		  if (projectCode!=null){
		  
		  return ActionSupport.SUCCESS;
		  
		  }else{
		  
		  return ActionSupport.ERROR; }
		 
		
		}
		
		return ActionSupport.LOGIN;

	}

	public String display() {
		logger.warn(">>>>>>>>>>>>mostrando pantalla display");
		Utilities utilities = new Utilities();
		if (!utilities.hayUsuarioEnSession(session)){
			return ActionSupport.LOGIN;
		}
		user = (UserSession)session.get("usuario");
		

		return NONE;

	}

	public List<Coordinator> getListCoordinators() {
		return listCoordinators;
	}

	public void setListCoordinators(List<Coordinator> listCoordinators) {
		this.listCoordinators = listCoordinators;
	}

	public List<Contractor> getListContractors() {
		return listContractors;
	}

	public void setListContractors(List<Contractor> listContractors) {
		this.listContractors = listContractors;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getCoordinatorId() {
		return coordinatorId;
	}

	public void setCoordinatorId(String coordinatorId) {
		this.coordinatorId = coordinatorId;
	}

	public String getContractorId() {
		return contractorId;
	}

	public void setContractorId(String contractorId) {
		this.contractorId = contractorId;
	}

	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	public UserSession getUser() {
		return user;
	}

	public void setUser(UserSession user) {
		this.user = user;
	}

	
}
