package com.ccalvouoc.actions;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.FilesDao;
import com.ccalvouoc.orm.Files;
import com.ccalvouoc.utils.FileUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class DownloadFileAction extends ActionSupport implements SessionAware{
	
	

	private Map session;
	private UserSession user;		
	private InputStream fileInputStream;
	private int fileId;
	private String originalName;
	
	private static final Logger logger = Logger
			.getLogger(DownloadFileAction.class.getName());

	
    @Override
    public String execute(){    	
    	try {
    		Utilities utilities = new Utilities();
    		user= utilities.getUserSession(session);		
    		if (user==null){			
    			return ActionSupport.LOGIN;
    		}	
    		
    		FilesDao filesDao = new FilesDao();
    		if(fileId < 1) {
    			return ActionSupport.SUCCESS;    			
    		}
    		
    		Files fileInDB = filesDao.fileById(fileId);    	
    		
    		// Se recuperan los datos del fichero en BBDD
    		String filePath = fileInDB.getPath();
    		String fileName = fileInDB.getSystemName();		   
    		originalName = fileInDB.getOriginalName();
    		
    		//Se recupera el fichero del sistema de archivos
    		fileInputStream = FileUtils.getFile(filePath, fileName);
    		return ActionSupport.SUCCESS;
     
	    } catch (Exception e) {        	
	    	logger.error(e.getMessage(), e);
	        return INPUT;
	    } 
    }
	
	
	
	
	
	public Map getSession() {
		return session;
	}
	public void setSession(Map session) {
		this.session = session;
	}
	public UserSession getUser() {
		return user;
	}
	public void setUser(UserSession user) {
		this.user = user;
	}
	public InputStream getFileInputStream() {
		return fileInputStream;
	}
	public void setFileInputStream(InputStream fileInputStream) {
		this.fileInputStream = fileInputStream;
	}
	public int getFileId() {
		return fileId;
	}
	public void setFileId(int fileId) {
		this.fileId = fileId;
	}

	public String getOriginalName() {
		return originalName;
	}

	public void setOriginalName(String originalName) {
		this.originalName = originalName;
	}

		
}
