package com.ccalvouoc.actions;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.ControlVisitDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.orm.ControlVisit;
import com.ccalvouoc.orm.Project;
import com.ccalvouoc.utils.EmailUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class NewControlVisitAction extends ActionSupport implements SessionAware {
	private static final Logger logger = Logger
			.getLogger(DoNewProjectAction.class.getName());

	private Project project;
	private String code;
	

	private Map session;
	private UserSession user;
	
	//datos form
	private String dateNewControlVisit;
	private String date;

	@Override
	public String execute() throws Exception {
		
		//----------------
		try {
			
			
			Utilities utilities = new Utilities();
			user = utilities.getUserSession(session);			
			if (user==null){				
				return ActionSupport.LOGIN;
			}
			ProjectDao projectDao = new ProjectDao();
			project = projectDao.getProject(code);
			
			setDateFromInput();
			if(!validateForm()){
				
				return ActionSupport.ERROR;	
			}
			
		
		
			ControlVisitDao controlVisitDao = new ControlVisitDao();

			
			controlVisitDao.createNewControlVisit(code,new Date(Long.parseLong(date)));
		
		} catch(Exception ex) {
		
			logger.error(ex.getMessage(), ex);
			addActionError("Ha ocurrido algún problema y no se ha completado la operación. Vuelva a intentarlo.");
			return ActionSupport.ERROR;		
		}		
		return ActionSupport.SUCCESS;
		//----------------
		
		
		

		

	}
	public boolean validateForm() {
		Date dateFormattedDate= new Date(Long.parseLong(date));
		
		ControlVisitDao controlVisitDao = new ControlVisitDao();
		ControlVisit controlVisit = controlVisitDao.getControlVisit(code,dateFormattedDate);
		
		if (controlVisit!=null ){
			addActionError("Ya existe una visita en esta fecha. Modifique la visita o cree una visita en una fecha diferente.");
			return false;
		}
		return true;
	}

	public String display() {
		logger.warn(">>>>>>>>>>>>mostrando pantalla display");
		Utilities utilities = new Utilities();
		if (!utilities.hayUsuarioEnSession(session)) {
			return ActionSupport.LOGIN;
		}
		user = (UserSession) session.get("usuario");
		ProjectDao projectDao = new ProjectDao();
		project = projectDao.getProject(code);

		
		return NONE;

	}

	private void setDateFromInput() {
	
		
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");

		if (!dateNewControlVisit.isEmpty()) {
			try {
				 Long dateLong = formatter.parse(dateNewControlVisit).getTime();
				 date = dateLong.toString();
				
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		
		
		
		

	}

	

	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	public UserSession getUser() {
		return user;
	}

	public void setUser(UserSession user) {
		this.user = user;
	}

	public Project getProject() {
		return project;
	}

	public void setProject(Project project) {
		this.project = project;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getDateNewControlVisit() {
		return dateNewControlVisit;
	}

	public void setDateNewControlVisit(String dateNewControlVisit) {
		this.dateNewControlVisit = dateNewControlVisit;
	}

	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}



	
}
