package com.ccalvouoc.actions;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.ControlVisitDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.orm.ControlVisit;
import com.ccalvouoc.orm.Project;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class ProjectClosureAction extends ActionSupport implements SessionAware {
	private static final Logger logger = Logger
			.getLogger(DoNewProjectAction.class.getName());

	private Project project;
	private String code;
	

	private Map session;
	private UserSession user;
	
	//datos form
	private String dateClosure;
	private String comments;

	@Override
	public String execute() throws Exception {

		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);
		
		if (user == null) {

			return ActionSupport.LOGIN;
		}
	
		closeProject();
		
		
	
		return ActionSupport.SUCCESS;

	}

	public String display() {
		logger.warn(">>>>>>>>>>>>mostrando pantalla display");
		Utilities utilities = new Utilities();
		if (!utilities.hayUsuarioEnSession(session)) {
			return ActionSupport.LOGIN;
		}
		user = (UserSession) session.get("usuario");
		ProjectDao projectDao = new ProjectDao();
		project = projectDao.getProject(code);

		
		return NONE;

	}

	private void closeProject() {
		ProjectDao projectDao = new ProjectDao();
		Project projectToUpdate = projectDao.getProject(project.getId());
		
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");

		if (!dateClosure.isEmpty()) {
			try {
				Date date = formatter.parse(dateClosure);
				
				project = projectDao.closeProject(project.getId(), date, comments);
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		
		
		
		

	}

	

	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	public UserSession getUser() {
		return user;
	}

	public void setUser(UserSession user) {
		this.user = user;
	}

	public Project getProject() {
		return project;
	}

	public void setProject(Project project) {
		this.project = project;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getDateClosure() {
		return dateClosure;
	}

	public void setDateClosure(String dateClosure) {
		this.dateClosure = dateClosure;
	}

	public String getComments() {
		return comments;
	}

	public void setComments(String comments) {
		this.comments = comments;
	}

	
}
