package com.ccalvouoc.actions;

import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.CompanyDao;
import com.ccalvouoc.dao.FilesDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.dao.UserDao;
import com.ccalvouoc.orm.Company;
import com.ccalvouoc.orm.Contractor;
import com.ccalvouoc.orm.Files;
import com.ccalvouoc.orm.Project;
import com.ccalvouoc.orm.SiteManager;
import com.ccalvouoc.orm.User;
import com.ccalvouoc.utils.FileUtils;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class ProjectEditionAction extends ActionSupport implements SessionAware {
	private static final Logger logger = Logger
			.getLogger(ProjectEditionAction.class.getName());

	private Project project;
	private String code;
	private String dateStartInput;

	private Map session;
	private UserSession user;
	
	private File inputDocAvisoPrevio;
	private String inputDocAvisoPrevioContentType;
	private String inputDocAvisoPrevioFileName;	
	
	private File inputDocTC2;
	private String inputDocTC2ContentType;
	private String inputDocTC2FileName;	
	
	private File inputDocEPIs;
	private String inputDocEPIsContentType;
	private String inputDocEPIsFileName;	
	
	private File inputDocAprobacionPSS;
	private String inputDocAprobacionPSSContentType;
	private String inputDocAprobacionPSSFileName;	
	
	private File inputDocAperturaCentro;
	private String inputDocAperturaCentroContentType;
	private String inputDocAperturaCentroFileName;	
	
	private File inputDocIncidencias;
	private String inputDocIncidenciasContentType;
	private String inputDocIncidenciasFileName;	
	
	private File inputDocSubcontratistas;
	private String inputDocSubcontratistasContentType;
	private String inputDocSubcontratistasFileName;	
	
	private File inputDocPlanObra;
	private String inputDocPlanObraContentType;
	private String inputDocPlanObraFileName;	
	
	private File inputDocITV;
	private String inputDocITVContentType;
	private String inputDocITVFileName;	
	
	private File inputDocHospitales;
	private String inputDocHospitalesContentType;
	private String inputDocHospitalesFileName;	
	
	private File inputDocOtros1;
	private String inputDocOtros1ContentType;
	private String inputDocOtros1FileName;	
	
	private File inputDocOtros2;
	private String inputDocOtros2ContentType;
	private String inputDocOtros2FileName;	
	
	

	@Override
	public String execute() throws Exception {

		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);

		if (user == null) {
			return ActionSupport.LOGIN;
		}
		
		updateProject();
	
		return ActionSupport.SUCCESS;

	}

	public String display() {
		logger.warn(">>>>>>>>>>>>mostrando pantalla display");
		Utilities utilities = new Utilities();
		if (!utilities.hayUsuarioEnSession(session)) {
			return ActionSupport.LOGIN;
		}
		user = (UserSession) session.get("usuario");
		ProjectDao projectDao = new ProjectDao();
		project = projectDao.getProject(code);

		
		return NONE;

	}

	private void updateProject() throws Exception {

		
		ProjectDao projectDao = new ProjectDao();

		Project projectToUpdate = projectDao.getProject(project.getId());
		
		
		setDataProjectToUpdate(projectToUpdate, project);

		project = projectDao.saveProject(projectToUpdate);
	}
	

	private void setDataProjectToUpdate(Project projectToUpdate,
			Project projectData) throws Exception {
		projectToUpdate.setBudget(projectData.getBudget());

		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");

		if (!dateStartInput.isEmpty()) {
			try {
				Date date = formatter.parse(dateStartInput);
				System.out.println("DATE"+date+ "dateStartInput:"+dateStartInput);
				projectToUpdate.setDateStart(date);
			} catch (ParseException e) {
				logger.error(e.getMessage(), e);
			}

		}
		projectToUpdate.setMonths(projectData.getMonths());
		projectToUpdate.setPk(projectData.getPk());
		projectToUpdate.setRoad(projectData.getRoad());

		setDataSiteManagerToUpdate(projectToUpdate);
		
		//grabamos los documentos en el sistema de archivos
		saveAllDocs(projectToUpdate);		
	}

	private void setDataSiteManagerToUpdate(Project projectToUpdate) throws Exception {		
		if(projectToUpdate.getSiteManager()==null ) {
			projectToUpdate.setSiteManager(new SiteManager());			
			int idComp = projectToUpdate.getContractor().getCompany().getId();
			CompanyDao companyDao = new CompanyDao();
			Company comp = companyDao.companyById(idComp);
			projectToUpdate.getSiteManager().setCompany(comp);
		}
		projectToUpdate.getSiteManager().setEmail(project.getSiteManager().getEmail());
		projectToUpdate.getSiteManager().setName(project.getSiteManager().getName());
		projectToUpdate.getSiteManager().setNif(project.getSiteManager().getNif());
		projectToUpdate.getSiteManager().setTelephone(project.getSiteManager().getTelephone());			
	}
	
	
	private void saveAllDocs(Project projectToUpdate) throws Exception {
		
		if(inputDocAvisoPrevio!= null ){
			
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByPreviousAdvise();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocAvisoPrevio, "AvisoPrevio", inputDocAvisoPrevioFileName, inputDocAvisoPrevioContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocAvisoPrevio, "AvisoPrevio", inputDocAvisoPrevioFileName, inputDocAvisoPrevioContentType);
			}			
			projectToUpdate.getDocuments().setFilesByPreviousAdvise(updatedFiles);
		}
		
		if(inputDocTC2!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByTc2();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocTC2, "TC2", inputDocTC2FileName, inputDocTC2ContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocTC2, "TC2", inputDocTC2FileName, inputDocTC2ContentType);
			}			
			projectToUpdate.getDocuments().setFilesByTc2(updatedFiles);
		}
		
		if(inputDocEPIs!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByEpis();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocEPIs, "EPIs", inputDocEPIsFileName, inputDocEPIsContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocEPIs, "EPIs", inputDocEPIsFileName, inputDocEPIsContentType);
			}			
			projectToUpdate.getDocuments().setFilesByEpis(updatedFiles);
		}
		
		if(inputDocAprobacionPSS!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByPss();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocAprobacionPSS, "PSS", inputDocAprobacionPSSFileName, inputDocAprobacionPSSContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocAprobacionPSS, "PSS", inputDocAprobacionPSSFileName, inputDocAprobacionPSSContentType);
			}			
			projectToUpdate.getDocuments().setFilesByPss(updatedFiles);
		}
		
		
		if(inputDocAperturaCentro!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByOpeningWorkplace();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocAperturaCentro, "AperturaCentro", inputDocAperturaCentroFileName, inputDocAperturaCentroContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocAperturaCentro, "AperturaCentro", inputDocAperturaCentroFileName, inputDocAperturaCentroContentType);
			}			
			projectToUpdate.getDocuments().setFilesByOpeningWorkplace(updatedFiles);
		}	
		
		if(inputDocIncidencias!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByIncidentsBook();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocIncidencias, "Incidencias", inputDocIncidenciasFileName, inputDocIncidenciasContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocIncidencias, "Incidencias", inputDocIncidenciasFileName, inputDocIncidenciasContentType);
			}			
			projectToUpdate.getDocuments().setFilesByIncidentsBook(updatedFiles);
		}		
		
		if(inputDocSubcontratistas!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesBySubcontractingBook();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocSubcontratistas, "Subcontratistas", inputDocSubcontratistasFileName, inputDocSubcontratistasContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocSubcontratistas, "Subcontratistas", inputDocSubcontratistasFileName, inputDocSubcontratistasContentType);
			}			
			projectToUpdate.getDocuments().setFilesBySubcontractingBook(updatedFiles);
		}
		
		
		if(inputDocPlanObra!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByWorkPlan();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocPlanObra, "PlanDeObra", inputDocPlanObraFileName, inputDocPlanObraContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocPlanObra, "PlanDeObra", inputDocPlanObraFileName, inputDocPlanObraContentType);
			}			
			projectToUpdate.getDocuments().setFilesByWorkPlan(updatedFiles);
		}	
		
		
		if(inputDocITV!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByItv();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocITV, "ITV", inputDocITVFileName, inputDocITVContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocITV, "ITV", inputDocITVFileName, inputDocITVContentType);
			}			
			projectToUpdate.getDocuments().setFilesByItv(updatedFiles);
		}	
		
		
		if(inputDocHospitales!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByHospitals();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocHospitales, "Hospitales", inputDocHospitalesFileName, inputDocHospitalesContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocHospitales, "Hospitales", inputDocHospitalesFileName, inputDocHospitalesContentType);
			}			
			projectToUpdate.getDocuments().setFilesByHospitals(updatedFiles);
		}	
				
		
		if(inputDocOtros1!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByOther1();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocOtros1, "Otros1", inputDocOtros1FileName, inputDocOtros1ContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocOtros1, "Otros1", inputDocOtros1FileName, inputDocOtros1ContentType);
			}			
			projectToUpdate.getDocuments().setFilesByOther1(updatedFiles);
		}	
		
		if(inputDocOtros2!= null ){
			Files filesToBeUpdated = projectToUpdate.getDocuments().getFilesByOther2();
			Files updatedFiles = null;
			if(filesToBeUpdated !=null) {
				//Actualizamos el documento
				updatedFiles = updateDoc(filesToBeUpdated.getId(), inputDocOtros2, "Otros2", inputDocOtros2FileName, inputDocOtros2ContentType);
			}else {
				//Grabamos el documento
				updatedFiles = saveDoc(inputDocOtros2, "Otros2", inputDocOtros2FileName, inputDocOtros2ContentType);
			}			
			projectToUpdate.getDocuments().setFilesByOther2(updatedFiles);
		}

	}
	
	private Files saveDoc(File docFile, String docName, String clientDocName, String docContentType) throws Exception {  		
		
		String filePath = getFilePath();
    	String docNameInServer = getDocName(docName, clientDocName);
    	
    	UserDao userDao = new UserDao();
    	User userSaving = userDao.getUser(user.getId());
		
		//Se graba en BBDD y obtenemos el id		
		Files fileToBeSave = new Files();
		fileToBeSave.setUser(userSaving);
		fileToBeSave.setOriginalName(clientDocName);
		fileToBeSave.setSystemName(docNameInServer);
		fileToBeSave.setPath(filePath);
		fileToBeSave.setTypeFile(docContentType);
		fileToBeSave.setDate(new Date());		
		FilesDao filesDao = new FilesDao();
		int idNewFile = filesDao.addFile(fileToBeSave);    	

    	//Se graba la imagen original en el sistema de archivos
    	FileUtils.saveFileOnDisk(docFile, docNameInServer, filePath);
    	
    	
    	//Devolvemos el registro en la tabla Files correspondiente al fichero grabado
    	Files savedFile = filesDao.fileById(idNewFile);    	
    	return savedFile;

	}
	
	private Files updateDoc(int idFileToBeUpdated, File docFile, String docName, String clientDocName, String docContentType) throws Exception {  			
		
		String filePath = getFilePath();
    	String docNameInServer = getDocName(docName, clientDocName);
    	
    	UserDao userDao = new UserDao();
    	User userSaving = userDao.getUser(user.getId());
		
		//Se actualiza en BBDD 
		FilesDao filesDao = new FilesDao();
    	Files fileToBeUpdated = filesDao.fileById(idFileToBeUpdated);
		fileToBeUpdated.setUser(userSaving);
		fileToBeUpdated.setOriginalName(clientDocName);
		fileToBeUpdated.setSystemName(docNameInServer);
		fileToBeUpdated.setPath(filePath);
		fileToBeUpdated.setTypeFile(docContentType);
		fileToBeUpdated.setDate(new Date());		
		filesDao.mergeFile(fileToBeUpdated);    	

    	//Se graba la imagen original en el sistema de archivos
    	FileUtils.saveFileOnDisk(docFile, docNameInServer, filePath);
    	

    	//Devolvemos el registro en la tabla Files correspondiente al fichero actualizado 	
    	return fileToBeUpdated;

	}
	
	private String getFilePath() {
		String filePath = "";    	
		filePath = "PSSfiles" +  File.separator + project.getId();		
        //FilesUtil.saveFile(getFile(), getFileFileName(), context.getRealPath("") + File.separator + filesPath);
    	String directorioRaiz = System.getenv("OPENSHIFT_DATA_DIR");
    	if(directorioRaiz !=null && !directorioRaiz.equals("")) {
    		filePath = directorioRaiz + File.separator + filePath;        		
    	} else {
    		filePath = "C:" + File.separator + filePath;  
    	}
    	return filePath;		
	}	
	
	
    private String getDocName(String docName, String clientDocName) {    	
    	String extension = clientDocName.substring(clientDocName.lastIndexOf('.'));   
    	StringBuilder sb = new StringBuilder();
    	sb.append(project.getId()).append(docName).append(extension);    	
    	return sb.toString();
    }
	
	
	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	public UserSession getUser() {
		return user;
	}

	public void setUser(UserSession user) {
		this.user = user;
	}

	public Project getProject() {
		return project;
	}

	public void setProject(Project project) {
		this.project = project;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getDateStartInput() {
		return dateStartInput;
	}

	public void setDateStartInput(String dateStartInput) {
		this.dateStartInput = dateStartInput;
	}

	public File getInputDocAvisoPrevio() {
		return inputDocAvisoPrevio;
	}

	public void setInputDocAvisoPrevio(File inputDocAvisoPrevio) {
		this.inputDocAvisoPrevio = inputDocAvisoPrevio;
	}

	public File getInputDocTC2() {
		return inputDocTC2;
	}

	public void setInputDocTC2(File inputDocTC2) {
		this.inputDocTC2 = inputDocTC2;
	}

	public File getInputDocEPIs() {
		return inputDocEPIs;
	}

	public void setInputDocEPIs(File inputDocEPIs) {
		this.inputDocEPIs = inputDocEPIs;
	}

	public File getInputDocAprobacionPSS() {
		return inputDocAprobacionPSS;
	}

	public void setInputDocAprobacionPSS(File inputDocAprobacionPSS) {
		this.inputDocAprobacionPSS = inputDocAprobacionPSS;
	}

	public File getInputDocAperturaCentro() {
		return inputDocAperturaCentro;
	}

	public void setInputDocAperturaCentro(File inputDocAperturaCentro) {
		this.inputDocAperturaCentro = inputDocAperturaCentro;
	}

	public File getInputDocIncidencias() {
		return inputDocIncidencias;
	}

	public void setInputDocIncidencias(File inputDocIncidencias) {
		this.inputDocIncidencias = inputDocIncidencias;
	}

	public File getInputDocSubcontratistas() {
		return inputDocSubcontratistas;
	}

	public void setInputDocSubcontratistas(File inputDocSubcontratistas) {
		this.inputDocSubcontratistas = inputDocSubcontratistas;
	}

	public File getInputDocPlanObra() {
		return inputDocPlanObra;
	}

	public void setInputDocPlanObra(File inputDocPlanObra) {
		this.inputDocPlanObra = inputDocPlanObra;
	}

	public File getInputDocITV() {
		return inputDocITV;
	}

	public void setInputDocITV(File inputDocITV) {
		this.inputDocITV = inputDocITV;
	}

	public File getInputDocHospitales() {
		return inputDocHospitales;
	}

	public void setInputDocHospitales(File inputDocHospitales) {
		this.inputDocHospitales = inputDocHospitales;
	}

	public File getInputDocOtros1() {
		return inputDocOtros1;
	}

	public void setInputDocOtros1(File inputDocOtros1) {
		this.inputDocOtros1 = inputDocOtros1;
	}

	public File getInputDocOtros2() {
		return inputDocOtros2;
	}

	public void setInputDocOtros2(File inputDocOtros2) {
		this.inputDocOtros2 = inputDocOtros2;
	}

	public void setInputDocAvisoPrevioContentType(
			String inputDocAvisoPrevioContentType) {
		this.inputDocAvisoPrevioContentType = inputDocAvisoPrevioContentType;
	}

	public void setInputDocAvisoPrevioFileName(String inputDocAvisoPrevioFileName) {
		this.inputDocAvisoPrevioFileName = inputDocAvisoPrevioFileName;
	}

	public void setInputDocTC2ContentType(String inputDocTC2ContentType) {
		this.inputDocTC2ContentType = inputDocTC2ContentType;
	}

	public void setInputDocTC2FileName(String inputDocTC2FileName) {
		this.inputDocTC2FileName = inputDocTC2FileName;
	}

	public void setInputDocEPIsContentType(String inputDocEPIsContentType) {
		this.inputDocEPIsContentType = inputDocEPIsContentType;
	}

	public void setInputDocEPIsFileName(String inputDocEPIsFileName) {
		this.inputDocEPIsFileName = inputDocEPIsFileName;
	}

	public void setInputDocAprobacionPSSContentType(
			String inputDocAprobacionPSSContentType) {
		this.inputDocAprobacionPSSContentType = inputDocAprobacionPSSContentType;
	}

	public void setInputDocAprobacionPSSFileName(
			String inputDocAprobacionPSSFileName) {
		this.inputDocAprobacionPSSFileName = inputDocAprobacionPSSFileName;
	}

	public void setInputDocAperturaCentroContentType(
			String inputDocAperturaCentroContentType) {
		this.inputDocAperturaCentroContentType = inputDocAperturaCentroContentType;
	}

	public void setInputDocAperturaCentroFileName(
			String inputDocAperturaCentroFileName) {
		this.inputDocAperturaCentroFileName = inputDocAperturaCentroFileName;
	}

	public void setInputDocIncidenciasContentType(
			String inputDocIncidenciasContentType) {
		this.inputDocIncidenciasContentType = inputDocIncidenciasContentType;
	}

	public void setInputDocIncidenciasFileName(String inputDocIncidenciasFileName) {
		this.inputDocIncidenciasFileName = inputDocIncidenciasFileName;
	}

	public void setInputDocSubcontratistasContentType(
			String inputDocSubcontratistasContentType) {
		this.inputDocSubcontratistasContentType = inputDocSubcontratistasContentType;
	}

	public void setInputDocSubcontratistasFileName(
			String inputDocSubcontratistasFileName) {
		this.inputDocSubcontratistasFileName = inputDocSubcontratistasFileName;
	}

	public void setInputDocPlanObraContentType(String inputDocPlanObraContentType) {
		this.inputDocPlanObraContentType = inputDocPlanObraContentType;
	}

	public void setInputDocPlanObraFileName(String inputDocPlanObraFileName) {
		this.inputDocPlanObraFileName = inputDocPlanObraFileName;
	}

	public void setInputDocITVContentType(String inputDocITVContentType) {
		this.inputDocITVContentType = inputDocITVContentType;
	}

	public void setInputDocITVFileName(String inputDocITVFileName) {
		this.inputDocITVFileName = inputDocITVFileName;
	}

	public void setInputDocHospitalesContentType(
			String inputDocHospitalesContentType) {
		this.inputDocHospitalesContentType = inputDocHospitalesContentType;
	}

	public void setInputDocHospitalesFileName(String inputDocHospitalesFileName) {
		this.inputDocHospitalesFileName = inputDocHospitalesFileName;
	}

	public void setInputDocOtros1ContentType(String inputDocOtros1ContentType) {
		this.inputDocOtros1ContentType = inputDocOtros1ContentType;
	}

	public void setInputDocOtros1FileName(String inputDocOtros1FileName) {
		this.inputDocOtros1FileName = inputDocOtros1FileName;
	}

	public void setInputDocOtros2ContentType(String inputDocOtros2ContentType) {
		this.inputDocOtros2ContentType = inputDocOtros2ContentType;
	}

	public void setInputDocOtros2FileName(String inputDocOtros2FileName) {
		this.inputDocOtros2FileName = inputDocOtros2FileName;
	}

	
	
	
}
