package com.ccalvouoc.actions;

import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.SessionAware;

import com.ccalvouoc.dao.ContractorDao;
import com.ccalvouoc.dao.CoordinatorDao;
import com.ccalvouoc.dao.ProjectDao;
import com.ccalvouoc.dao.UserDao;
import com.ccalvouoc.ejemplo.PrimeraClase;
import com.ccalvouoc.orm.User;
import com.ccalvouoc.utils.UserSession;
import com.ccalvouoc.utils.Utilities;
import com.opensymphony.xwork2.ActionSupport;

public class UserProfileAction extends ActionSupport implements SessionAware {
	private static final Logger logger = Logger
			.getLogger(UserProfileAction.class.getName());

	private Map session;
	private UserSession user;

	// Variables que recoge del formulario
	private User userData;

	public UserProfileAction() {

	}

	@Override
	public String execute() throws Exception {
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);
		if (user != null) {

			
			if (!validateForm()){

				return ActionSupport.ERROR;
			}
			// cargar datos en el usuario
			User userToUpdate = setNewDataInUser();
			UserDao userDao = new UserDao();
			userDao.mergeUser(userToUpdate);
			
			// Graba los datos

		

			return ActionSupport.SUCCESS;

		
		}



		return ActionSupport.LOGIN;

	}

	public String display() {
		Utilities utilities = new Utilities();
		user = utilities.getUserSession(session);

		if (user == null) {
			return ActionSupport.LOGIN;
		}

		UserDao userDao = new UserDao();
		userData = userDao.getUser(user.getId());

		return NONE;

	}

	private boolean validateForm() {
		if (user.getId() == 1) {
			return validateManager();

		} else if (user.getId() == 2) {
			return validateTechnician();

		} else if (user.getId() == 3) {
			return validateCoordinator();

		} else if (user.getId() == 4) {
			return validateContractor();

		}
		return true;

	}

	private boolean validateManager() {

		if (userData.getManager().getName() == null
				|| userData.getManager().getName().equals("")) {
			
			addActionError("Debe rellenar en el campo 'Nombre'");
			return false;
		}else if (userData.getManager().getNif() == null
				|| userData.getManager().getNif().equals("")) {
			
			addActionError("Debe rellenar el campo 'Nif'");
			return false;
		}else if (userData.getManager().getEmail() == null
				|| userData.getManager().getEmail().equals("")) {
			
			addActionError("Debe rellenar el campo 'eMail'");
			return false;
		}
		return true;
	}

	private boolean validateTechnician() {
		if (userData.getTechnician().getName() == null
				|| userData.getTechnician().getName().equals("")) {
			
			addActionError("Debe rellenar en el campo 'Nombre'");
			return false;
		}else if (userData.getTechnician().getNif() == null
				|| userData.getTechnician().getNif().equals("")) {
			
			addActionError("Debe rellenar el campo 'Nif'");
			return false;
		}else if (userData.getTechnician().getEmail() == null
				|| userData.getTechnician().getEmail().equals("")) {
			
			addActionError("Debe rellenar el campo 'eMail'");
			return false;
		}else if (userData.getTechnician().getTelephone() == null
				|| userData.getTechnician().getTelephone().equals("")) {
			
			addActionError("Debe rellenar el campo 'Teléfono'");
			return false;
		}
		return true;
		
	}

	private boolean validateCoordinator() {
		if (userData.getCoordinator().getName() == null
				|| userData.getCoordinator().getName().equals("")) {
			
			addActionError("Debe rellenar en el campo 'Nombre'");
			return false;
		}else if (userData.getCoordinator().getNif() == null
				|| userData.getCoordinator().getNif().equals("")) {
			
			addActionError("Debe rellenar el campo 'Nif'");
			return false;
		}else if (userData.getCoordinator().getEmail() == null
				|| userData.getCoordinator().getEmail().equals("")) {
			
			addActionError("Debe rellenar el campo 'eMail'");
			return false;
		}else if (userData.getCoordinator().getTelephone() == null
				|| userData.getCoordinator().getTelephone().equals("")) {
			
			addActionError("Debe rellenar el campo 'Teléfono'");
			return false;
		}

		return true;
	}

	private boolean validateContractor() {
		return true;
	}

	private User setNewDataInUser() {
		User userToUpdate;
		UserDao userDao = new UserDao();
		userToUpdate = userDao.getUser(user.getId());
		if (user.getId() == 1) {
			userToUpdate.getManager().setName(userData.getManager().getName());
			userToUpdate.getManager().setNif(userData.getManager().getNif());
			userToUpdate.getManager()
					.setEmail(userData.getManager().getEmail());

		} else if (user.getId() == 2) {
			userToUpdate.getTechnician().setName(
					userData.getTechnician().getName());
			userToUpdate.getTechnician().setNif(
					userData.getTechnician().getNif());
			userToUpdate.getTechnician().setEmail(
					userData.getTechnician().getEmail());
			userToUpdate.getTechnician().setTelephone(
					userData.getTechnician().getTelephone());
		} else if (user.getId() == 3) {
			userToUpdate.getCoordinator().setName(
					userData.getCoordinator().getName());
			userToUpdate.getCoordinator().setNif(
					userData.getCoordinator().getNif());
			userToUpdate.getCoordinator().setEmail(
					userData.getCoordinator().getEmail());
			userToUpdate.getCoordinator().setTelephone(
					userData.getCoordinator().getTelephone());

			userToUpdate.getCoordinator().getCompany()
					.setCif(userData.getCoordinator().getCompany().getCif());
			userToUpdate.getCoordinator().getCompany()
					.setName(userData.getCoordinator().getCompany().getName());
			userToUpdate
					.getCoordinator()
					.getCompany()
					.setTelephone(
							userData.getCoordinator().getCompany()
									.getTelephone());
			userToUpdate
					.getCoordinator()
					.getCompany()
					.setEmail(userData.getCoordinator().getCompany().getEmail());
		} else if (user.getId() == 4) {

			userToUpdate.getContractor().getCompany()
					.setCif(userData.getContractor().getCompany().getCif());
			userToUpdate.getContractor().getCompany()
					.setName(userData.getContractor().getCompany().getName());
			userToUpdate
					.getContractor()
					.getCompany()
					.setTelephone(
							userData.getContractor().getCompany()
									.getTelephone());
			userToUpdate.getContractor().getCompany()
					.setEmail(userData.getContractor().getCompany().getEmail());
		}
		
		return userToUpdate;
	}

	public User getUserData() {
		return userData;
	}

	public void setUserData(User userData) {
		this.userData = userData;
	}

	public Map getSession() {
		return session;
	}

	public void setSession(Map session) {
		this.session = session;
	}

	public UserSession getUser() {
		return user;
	}

	public void setUser(UserSession user) {
		this.user = user;
	}

}
