package com.ccalvouoc.dao;

import org.apache.log4j.Logger;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;

import com.ccalvouoc.orm.Company;
import com.ccalvouoc.orm.Files;

public class CompanyDao {
	
	private static final Logger logger = Logger.getLogger(CompanyDao.class.getName());
	private Session session;	
	
	
	public Company companyById(int id) {
		Company companyInDB = null;
		try {			
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();		
			companyInDB = (Company)session.get(Company.class, id);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return companyInDB;
	}

	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}
	
}
