package com.ccalvouoc.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.criterion.Restrictions;

import com.ccalvouoc.orm.Contractor;




public class ContractorDao {
	private static final Logger logger = Logger.getLogger(ContractorDao.class.getName());
	Session session;
	
	@SuppressWarnings("unchecked")
	public List<Contractor> listContractors(){
		List<Contractor> listContractors = null; 
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(Contractor.class);
			
			listContractors= criteria.list();
				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return listContractors;
	}
	
	@SuppressWarnings("unchecked")
	public Contractor getContractor(int id){
		Contractor contractor = null; 
		
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(Contractor.class);
			
			criteria.add(Restrictions.eq("id",id));
			contractor= (Contractor) criteria.list().get(0);
			
			
			/*			
			String hql = "FROM Project";
			Query query = session.createQuery(hql);
			listaNames = query.list();
			session.getTransaction().commit();
*/				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return contractor;
	}
	
	
	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}

}
