package com.ccalvouoc.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.criterion.Restrictions;


import com.ccalvouoc.orm.Coordinator;

public class CoordinatorDao {
	private static final Logger logger = Logger.getLogger(CoordinatorDao.class.getName());
	Session session;
	
	@SuppressWarnings("unchecked")
	public List<Coordinator> listCoordinators(){
		List<Coordinator> listCoordinators = null; 
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(Coordinator.class);
			
			listCoordinators= criteria.list();
			
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return listCoordinators;
	}
	
	@SuppressWarnings("unchecked")
	public Coordinator getCoordinator(int id){
		Coordinator coordinator = null; 
		
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(Coordinator.class);
			
			criteria.add(Restrictions.eq("id",id));
			coordinator= (Coordinator) criteria.list().get(0);
			
			
			/*			
			String hql = "FROM Project";
			Query query = session.createQuery(hql);
			listaNames = query.list();
			session.getTransaction().commit();
*/				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return coordinator;
	}
	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}

}
