package com.ccalvouoc.dao;



import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;

import com.ccalvouoc.orm.Files;



public class FilesDao {	
	
	private static final Logger logger = Logger.getLogger(FilesDao.class.getName());
	private Session session;	
	
	@SuppressWarnings("unchecked")
	public int addFile(Files file) {
		Integer id = 0;
		try {
			
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			session.beginTransaction();
			id = (Integer) session.save(file);
			session.getTransaction().commit();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return id.intValue();
	}
	
	
	@SuppressWarnings("unchecked")
	public void mergeFile(Files file) {
		try {

			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();			
			session.beginTransaction();
			session.merge(file);
			session.getTransaction().commit();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
	}
	
	
	public Files fileById(int id) {
		Files fileInDB = null;
		try {			
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();		
			fileInDB = (Files)session.get(Files.class, id);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return fileInDB;
	}
	
	
	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}
	


}
