package com.ccalvouoc.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;


import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;



import com.ccalvouoc.orm.News;
import com.ccalvouoc.orm.VwNews;

public class NewsDao {
	private static final Logger logger = Logger.getLogger(NewsDao.class.getName());
	Session session;
	
	@SuppressWarnings("unchecked")
	public List<VwNews> listNews(){
		List<VwNews> listNews = null; 
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(VwNews.class);
			
			criteria.addOrder(Order.desc("id.dateNews"));
			listNews= criteria.list();
				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return listNews;
	}
	
	@SuppressWarnings("unchecked")
	public News getNews(int id){
		News news = null; 
		
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(News.class);
			
			criteria.add(Restrictions.eq("id",id));
			news= (News) criteria.list().get(0);
			
			
			/*			
			String hql = "FROM Project";
			Query query = session.createQuery(hql);
			listaNames = query.list();
			session.getTransaction().commit();
*/				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return news;
	}
	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}

}
