package com.ccalvouoc.dao;



import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;




import com.ccalvouoc.orm.SiteManager;



public class SiteManagerDao {	
	
	private static final Logger logger = Logger.getLogger(SiteManagerDao.class.getName());
	private Session session;	
	
	@SuppressWarnings("unchecked")
	public int addSiteManager(SiteManager siteManager) {
		Integer id = 0;
		try {
			
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			session.beginTransaction();
			id = (Integer) session.save(siteManager);
			session.getTransaction().commit();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return id.intValue();
	}
	
	public SiteManager siteManagerById(int id) {
		SiteManager siteManagerInDB = null;
		try {			
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();		
			siteManagerInDB = (SiteManager)session.get(SiteManager.class, id);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return siteManagerInDB;
	}
	
	
	
	
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}
	


}
