package com.ccalvouoc.dao;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.criterion.Restrictions;

import com.ccalvouoc.orm.Project;
import com.ccalvouoc.orm.Technician;

public class TechnicianDao {
	private static final Logger logger = Logger.getLogger(ControlVisitDao.class.getName());
	Session session;
	
	@SuppressWarnings("unchecked")
	public Technician getTechnician(int id){
		Technician technician = null; 
		
		try{
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			
			Criteria criteria = session.createCriteria(Technician.class);
			
			criteria.add(Restrictions.eq("id",id));
			technician= (Technician) criteria.list().get(0);
			
			
			/*			
			String hql = "FROM Project";
			Query query = session.createQuery(hql);
			listaNames = query.list();
			session.getTransaction().commit();
*/				
		}catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if(session!=null && session.isOpen())
				session.close();
		}
		return technician;
	}
	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
	    return sessionFactory;
	}
}
