package com.ccalvouoc.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.criterion.Restrictions;

import com.ccalvouoc.orm.Files;
import com.ccalvouoc.orm.User;
import com.ccalvouoc.utils.UserSession;

public class UserDao {
	private static final Logger logger = Logger.getLogger(UserDao.class
			.getName());
	Session session;

	@SuppressWarnings("unchecked")
	public Boolean allowAccess(String user, String psw) {
		Boolean rightData = false;
		try {
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();

			Criteria criteria = session.createCriteria(User.class);
			criteria.add(Restrictions.eq("username", user));
		
			criteria.add(Restrictions.eq("password", psw));

			if (criteria.list().size() > 0) {
				rightData = true;
				
			}
			;
			/*
			 * String hql = "FROM Project"; Query query =
			 * session.createQuery(hql); listaNames = query.list();
			 * session.getTransaction().commit();
			 */
		} catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if (session != null && session.isOpen())
				session.close();
		}
		return rightData;
	}

	@SuppressWarnings("unchecked")
	public void mergeUser(User user) {
		try {

			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			session.beginTransaction();
			
			if (user.getId() == 1) {
				session.merge(user.getManager());
			} else if (user.getId() == 2) {
				session.merge(user.getTechnician());
				
			} else if (user.getId() == 3) {
				session.merge(user.getCoordinator());
				session.merge(user.getCoordinator().getCompany());

			} else {
				session.merge(user.getContractor().getCompany());
			}
			

			session.getTransaction().commit();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if (session != null && session.isOpen())
				session.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void mergePass(User user) {
		try {

			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();
			session.beginTransaction();
			
			
			session.merge(user);
			

			session.getTransaction().commit();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if (session != null && session.isOpen())
				session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public UserSession getUserSession(String userName, String psw) {
		UserSession userSession = null;
		User user = null;
		
		try {
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();

			Criteria criteria = session.createCriteria(User.class);
			
			criteria.add(Restrictions.eq("username", userName));
			criteria.add(Restrictions.eq("password", psw));
			if (criteria.list().size() != 0) {
				user = (User) criteria.list().get(0);
				userSession = new UserSession(user.getId(), user.getRole()
						.getId(), user.getUsername());
			}

		} catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if (session != null && session.isOpen())
				session.close();
		}
		return userSession;
	}

	public User getUser(int id) {

		User user = null;
		
		try {
			SessionFactory sessionFactory = createSessionFactory();
			Session session = sessionFactory.openSession();

			Criteria criteria = session.createCriteria(User.class);
			
			criteria.add(Restrictions.eq("id", id));
			if (criteria.list().size() != 0) {
				user = (User) criteria.list().get(0);

			}

		} catch (HibernateException e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			session.getTransaction().rollback();
		} finally {
			if (session != null && session.isOpen())
				session.close();
		}
		return user;
	}

	public static SessionFactory createSessionFactory() {
		SessionFactory sessionFactory = new AnnotationConfiguration()
				.configure().buildSessionFactory();
		return sessionFactory;
	}

}
