package com.ccalvouoc.orm;

// Generated 30-dic-2014 13:58:11 by Hibernate Tools 3.4.0.CR1

import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Company generated by hbm2java
 */
@Entity
@Table(name = "company", catalog = "jbossews")
public class Company implements java.io.Serializable {

	private int id;
	private Location location;
	private String name;
	private String cif;
	private String address;
	private String postalcode;
	private String telephone;
	private String fax;
	private String email;
	private Set<Technician> technicians = new HashSet<Technician>(0);
	private Set<SiteManager> siteManagers = new HashSet<SiteManager>(0);
	private Set<Contractor> contractors = new HashSet<Contractor>(0);
	private Set<Coordinator> coordinators = new HashSet<Coordinator>(0);
	private Set<Manager> managers = new HashSet<Manager>(0);

	public Company() {
	}

	public Company(int id) {
		this.id = id;
	}

	public Company(int id, Location location, String name, String cif,
			String address, String postalcode, String telephone, String fax,
			String email, Set<Technician> technicians,
			Set<SiteManager> siteManagers, Set<Contractor> contractors,
			Set<Coordinator> coordinators, Set<Manager> managers) {
		this.id = id;
		this.location = location;
		this.name = name;
		this.cif = cif;
		this.address = address;
		this.postalcode = postalcode;
		this.telephone = telephone;
		this.fax = fax;
		this.email = email;
		this.technicians = technicians;
		this.siteManagers = siteManagers;
		this.contractors = contractors;
		this.coordinators = coordinators;
		this.managers = managers;
	}

	@Id
	@Column(name = "ID", unique = true, nullable = false)
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "location_ID")
	public Location getLocation() {
		return this.location;
	}

	public void setLocation(Location location) {
		this.location = location;
	}

	@Column(name = "name", length = 45)
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "cif", length = 45)
	public String getCif() {
		return this.cif;
	}

	public void setCif(String cif) {
		this.cif = cif;
	}

	@Column(name = "address", length = 100)
	public String getAddress() {
		return this.address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	@Column(name = "postalcode", length = 5)
	public String getPostalcode() {
		return this.postalcode;
	}

	public void setPostalcode(String postalcode) {
		this.postalcode = postalcode;
	}

	@Column(name = "telephone", length = 10)
	public String getTelephone() {
		return this.telephone;
	}

	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}

	@Column(name = "fax", length = 45)
	public String getFax() {
		return this.fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	@Column(name = "email", length = 45)
	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "company")
	public Set<Technician> getTechnicians() {
		return this.technicians;
	}

	public void setTechnicians(Set<Technician> technicians) {
		this.technicians = technicians;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "company")
	public Set<SiteManager> getSiteManagers() {
		return this.siteManagers;
	}

	public void setSiteManagers(Set<SiteManager> siteManagers) {
		this.siteManagers = siteManagers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "company")
	public Set<Contractor> getContractors() {
		return this.contractors;
	}

	public void setContractors(Set<Contractor> contractors) {
		this.contractors = contractors;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "company")
	public Set<Coordinator> getCoordinators() {
		return this.coordinators;
	}

	public void setCoordinators(Set<Coordinator> coordinators) {
		this.coordinators = coordinators;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "company")
	public Set<Manager> getManagers() {
		return this.managers;
	}

	public void setManagers(Set<Manager> managers) {
		this.managers = managers;
	}

}
