package com.ccalvouoc.orm;

// Generated 30-dic-2014 13:58:11 by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Project generated by hbm2java
 */
@Entity
@Table(name = "project", catalog = "jbossews")
public class Project implements java.io.Serializable {

	private String id;
	private Contractor contractor;
	private SiteManager siteManager;
	private Coordinator coordinator;
	private Technician technician;
	private Date dateStart;
	private String title;
	private String road;
	private String pk;
	private Integer months;
	private Float budget;
	private Date created;
	private Date dataClose;
	private String closeComments;
	private Documents documents;
	private Set<ControlVisit> controlVisits = new HashSet<ControlVisit>(0);
	private Set<ProjectHasNews> projectHasNewses = new HashSet<ProjectHasNews>(
			0);

	public Project() {
	}

	public Project(String id) {
		this.id = id;
	}

	public Project(String id, Contractor contractor, SiteManager siteManager,
			Coordinator coordinator, Technician technician, Date dateStart,
			String title, String road, String pk, Integer months, Float budget,
			Date created, Date dataClose, String closeComments,
			Documents documents, Set<ControlVisit> controlVisits,
			Set<ProjectHasNews> projectHasNewses) {
		this.id = id;
		this.contractor = contractor;
		this.siteManager = siteManager;
		this.coordinator = coordinator;
		this.technician = technician;
		this.dateStart = dateStart;
		this.title = title;
		this.road = road;
		this.pk = pk;
		this.months = months;
		this.budget = budget;
		this.created = created;
		this.dataClose = dataClose;
		this.closeComments = closeComments;
		this.documents = documents;
		this.controlVisits = controlVisits;
		this.projectHasNewses = projectHasNewses;
	}

	@Id
	@Column(name = "ID", unique = true, nullable = false, length = 8)
	public String getId() {
		return this.id;
	}

	public void setId(String id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "contractor_ID")
	public Contractor getContractor() {
		return this.contractor;
	}

	public void setContractor(Contractor contractor) {
		this.contractor = contractor;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "site_manager_ID")
	public SiteManager getSiteManager() {
		return this.siteManager;
	}

	public void setSiteManager(SiteManager siteManager) {
		this.siteManager = siteManager;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "coordinator_ID")
	public Coordinator getCoordinator() {
		return this.coordinator;
	}

	public void setCoordinator(Coordinator coordinator) {
		this.coordinator = coordinator;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "technician_ID")
	public Technician getTechnician() {
		return this.technician;
	}

	public void setTechnician(Technician technician) {
		this.technician = technician;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "date_start", length = 19)
	public Date getDateStart() {
		return this.dateStart;
	}

	public void setDateStart(Date dateStart) {
		this.dateStart = dateStart;
	}

	@Column(name = "title", length = 100)
	public String getTitle() {
		return this.title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	@Column(name = "road", length = 45)
	public String getRoad() {
		return this.road;
	}

	public void setRoad(String road) {
		this.road = road;
	}

	@Column(name = "PK", length = 45)
	public String getPk() {
		return this.pk;
	}

	public void setPk(String pk) {
		this.pk = pk;
	}

	@Column(name = "months")
	public Integer getMonths() {
		return this.months;
	}

	public void setMonths(Integer months) {
		this.months = months;
	}

	@Column(name = "budget", precision = 12, scale = 0)
	public Float getBudget() {
		return this.budget;
	}

	public void setBudget(Float budget) {
		this.budget = budget;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "created", length = 19)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "data_close", length = 10)
	public Date getDataClose() {
		return this.dataClose;
	}

	public void setDataClose(Date dataClose) {
		this.dataClose = dataClose;
	}

	@Column(name = "close_comments", length = 1500)
	public String getCloseComments() {
		return this.closeComments;
	}

	public void setCloseComments(String closeComments) {
		this.closeComments = closeComments;
	}

	@OneToOne(fetch = FetchType.LAZY, mappedBy = "project")
	public Documents getDocuments() {
		return this.documents;
	}

	public void setDocuments(Documents documents) {
		this.documents = documents;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "project")
	public Set<ControlVisit> getControlVisits() {
		return this.controlVisits;
	}

	public void setControlVisits(Set<ControlVisit> controlVisits) {
		this.controlVisits = controlVisits;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "project")
	public Set<ProjectHasNews> getProjectHasNewses() {
		return this.projectHasNewses;
	}

	public void setProjectHasNewses(Set<ProjectHasNews> projectHasNewses) {
		this.projectHasNewses = projectHasNewses;
	}

}
