package com.ccalvouoc.orm;

// Generated 30-dic-2014 13:58:11 by Hibernate Tools 3.4.0.CR1

import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**
 * Technician generated by hbm2java
 */
@Entity
@Table(name = "technician", catalog = "jbossews")
public class Technician implements java.io.Serializable {

	private int id;
	private User user;
	private Company company;
	private String name;
	private String nif;
	private String email;
	private String telephone;
	private Set<Manager> managers = new HashSet<Manager>(0);
	private Set<Project> projects = new HashSet<Project>(0);

	public Technician() {
	}

	public Technician(User user, String name, String nif, String email) {
		this.user = user;
		this.name = name;
		this.nif = nif;
		this.email = email;
	}

	public Technician(User user, Company company, String name, String nif,
			String email, String telephone, Set<Manager> managers,
			Set<Project> projects) {
		this.user = user;
		this.company = company;
		this.name = name;
		this.nif = nif;
		this.email = email;
		this.telephone = telephone;
		this.managers = managers;
		this.projects = projects;
	}

	@GenericGenerator(name = "generator", strategy = "foreign", parameters = @Parameter(name = "property", value = "user"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column(name = "ID", unique = true, nullable = false)
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@OneToOne(fetch = FetchType.LAZY)
	@PrimaryKeyJoinColumn
	public User getUser() {
		return this.user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "company_ID")
	public Company getCompany() {
		return this.company;
	}

	public void setCompany(Company company) {
		this.company = company;
	}

	@Column(name = "name", nullable = false, length = 50)
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "nif", nullable = false, length = 10)
	public String getNif() {
		return this.nif;
	}

	public void setNif(String nif) {
		this.nif = nif;
	}

	@Column(name = "email", nullable = false, length = 100)
	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@Column(name = "telephone", length = 10)
	public String getTelephone() {
		return this.telephone;
	}

	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}

	@ManyToMany(fetch = FetchType.LAZY)
	@JoinTable(name = "manager_manages_technician", catalog = "jbossews", joinColumns = { @JoinColumn(name = "technician_ID", nullable = false, updatable = false) }, inverseJoinColumns = { @JoinColumn(name = "manager_ID", nullable = false, updatable = false) })
	public Set<Manager> getManagers() {
		return this.managers;
	}

	public void setManagers(Set<Manager> managers) {
		this.managers = managers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "technician")
	public Set<Project> getProjects() {
		return this.projects;
	}

	public void setProjects(Set<Project> projects) {
		this.projects = projects;
	}

}
